/*HEADER*******************************************************************
***************************************************************************
***
*** Copyright (c) 2000-2006 Vision Components
***
*** All rights reserved
***
*** This software embodies materials and concepts which are confidential
*** to Vision Components
***
*** File: fbench.c
***                                                            
*** Comments: 
*** 
***    benchmark for filter functions and miscelaneous other functions
***
*** Revision History:
***    Date          Version    Author  Changes
***    Oct 14, 2004  2.00       ME      Initial Version
***    Aug 23, 2006  2.03       ME      added JPEG benchmark
***
***************************************************************************
*END***********************************************************************/

#define NEW_IMAGE_VAR

#include <vcrt.h>
#include <flib.h>
#include <vclib.h>
#include <register.h>
#include <sysvar.h>
#include <macros.h>
#include "\ti\vclib\licence.h"


#define DX 640
#define DY 480


main()
{
image a, b, d; 
int i, t0, t1;
int pitch = getvar(VPITCH);
static int c[3][3];
static int w[5][5];

ImageAssign(&a, getvar(DISP_START),            DX, DY, pitch);
ImageAssign(&b, sysmalloc(pitch*DX/4, MIMAGE), DX, DY, pitch);
ImageAssign(&d, sysmalloc(pitch*DX/4, MIMAGE), DX, DY, pitch);

INIT_LICENCE();

print("FILTER BENCHMARK VS 1.0\n");
rs232rcv();


/* set ******************************************************************/

t0 = getvar(MSEC);

for(i=0; i<5; i++)
  {
  set(&a, 0xff);
  set(&a, 0x00);
  }

t1 = getvar(MSEC) - t0;
if (t1 < 0) t1 += 1000; 

print("set:         %d.%d msec\n",t1/10,t1-10*(t1/10));


/* robert ***************************************************************/

t0 = getvar(MSEC);

for(i=0; i<10; i++)
  robert(&a, &a);

t1 = getvar(MSEC) - t0;
if (t1 < 0) t1 += 1000; 

print("robert:      %d.%d msec\n",t1/10,t1-10*(t1/10));

/* ff3 ******************************************************************/

c[0][0]=1; c[0][1]=0; c[0][2]=-1;
c[1][0]=1; c[1][1]=0; c[1][2]=-1;
c[2][0]=1; c[2][1]=0; c[2][2]=-1;

t0 = getvar(MSEC);

for(i=0; i<10; i++)
  ff3(&a, &a, c, 0);

t1 = getvar(MSEC) - t0;
if (t1 < 0) t1 += 1000; 

print("ff3:         %d.%d msec\n",t1/10,t1-10*(t1/10));

/* ff5 ******************************************************************/

w[0][0]=1; w[0][1]=0; w[0][2]=0; w[0][3]=0; w[0][4]=-1;
w[1][0]=1; w[1][1]=0; w[1][2]=0; w[1][3]=0; w[1][4]=-1;
w[2][0]=1; w[2][1]=0; w[2][2]=0; w[2][3]=0; w[2][4]=-1;
w[3][0]=1; w[3][1]=0; w[3][2]=0; w[3][3]=0; w[3][4]=-1;
w[4][0]=1; w[4][1]=0; w[4][2]=0; w[4][3]=0; w[4][4]=-1;

t0 = getvar(MSEC);

ff5(&a, &a, w, -2);

t1 = getvar(MSEC) - t0;
if (t1 < 0) t1 += 1000; 

print("ff5:         %d msec\n",t1);

/* median3 **************************************************************/

t0 = getvar(MSEC);

for(i=0; i<10; i++)
  median3(&a, &a);

t1 = getvar(MSEC) - t0;
if (t1 < 0) t1 += 1000; 

print("median3:     %d.%d msec\n",t1/10,t1-10*(t1/10));

/* sobel ****************************************************************/

t0 = getvar(MSEC);

for(i=0; i<10; i++)
  sobel(&a, &a);

t1 = getvar(MSEC) - t0;
if (t1 < 0) t1 += 1000; 

print("sobel:       %d.%d msec\n",t1/10,t1-10*(t1/10));

/* laplace **************************************************************/

t0 = getvar(MSEC);

for(i=0; i<10; i++)
  laplace(&a, &a);

t1 = getvar(MSEC) - t0;
if (t1 < 0) t1 += 1000; 

print("laplace:     %d.%d msec\n",t1/10,t1-10*(t1/10));

/* subtract *************************************************************/

t0 = getvar(MSEC);

for(i=0; i<10; i++)
  sub2(&a, &b, &d);

t1 = getvar(MSEC) - t0;
if (t1 < 0) t1 += 1000; 

print("subtract:    %d.%d msec\n",t1/10,t1-10*(t1/10));

/* pyramid mean *********************************************************/

t0 = getvar(MSEC);
				 
for(i=0; i<10; i++)
  pyramid(&a, &a);

t1 = getvar(MSEC) - t0;
if (t1 < 0) t1 += 1000; 

print("pyramid mean:%d.%d msec\n",t1/10,t1-10*(t1/10));

/* pyramid max **********************************************************/

t0 = getvar(MSEC);
				 
for(i=0; i<10; i++)
  pyr_max(&a, &a);

t1 = getvar(MSEC) - t0;
if (t1 < 0) t1 += 1000; 

print("pyramid max: %d.%d msec\n",t1/10,t1-10*(t1/10));

/* pyramid min **********************************************************/

t0 = getvar(MSEC);
				 
for(i=0; i<10; i++)
  pyr_min(&a, &a);

t1 = getvar(MSEC) - t0;
if (t1 < 0) t1 += 1000; 

print("pyramid min: %d.%d msec\n",t1/10,t1-10*(t1/10));

/* copy *****************************************************************/

t0 = getvar(MSEC);
				 
for(i=0; i<10; i++)
  copy(&a, &b);

t1 = getvar(MSEC) - t0;
if (t1 < 0) t1 += 1000; 

print("copy:        %d.%d msec\n",t1/10,t1-10*(t1/10));

/* rotate90 *************************************************************/

t0 = getvar(MSEC);
				 
for(i=0; i<10; i++)
  rotate90r(&a, &b);

t1 = getvar(MSEC) - t0;
if (t1 < 0) t1 += 1000; 

print("rotate90:    %d.%d msec\n",t1/10,t1-10*(t1/10));

/* rotate180 inplace ****************************************************/

t0 = getvar(MSEC);
				 
for(i=0; i<10; i++)
  rotate180(&a, &a);

t1 = getvar(MSEC) - t0;
if (t1 < 0) t1 += 1000; 

print("rotate180inp:%d.%d msec\n",t1/10,t1-10*(t1/10));

/* rotate180 normal *****************************************************/

t0 = getvar(MSEC);
				 
for(i=0; i<10; i++)
  rotate180(&a, &b);

t1 = getvar(MSEC) - t0;
if (t1 < 0) t1 += 1000; 

print("rotate180:   %d.%d msec\n",t1/10,t1-10*(t1/10));

/* move_image_alpha *****************************************************/

t0 = getvar(MSEC);
				 
for(i=0; i<10; i++)
  move_image_alpha(&a, &d, 0.2, 0, 0);

t1 = getvar(MSEC) - t0;
if (t1 < 0) t1 += 1000; 

print("move_image:  %d.%d msec\n",t1/10,t1-10*(t1/10));

/* unsharp masking ******************************************************/

t0 = getvar(MSEC);
				 
for(i=0; i<10; i++)
  avgm(&a, &d, 32, 32);

t1 = getvar(MSEC) - t0;
if (t1 < 0) t1 += 1000; 

print("unsharp masking:  %d.%d msec\n",t1/10,t1-10*(t1/10));

/* histogram ************************************************************/

  {
  U32 hist[256];

  t0 = getvar(MSEC);

  for(i=0; i<10; i++)
    histo(&a, hist);

  t1 = getvar(MSEC) - t0;
  if (t1 < 0) t1 += 1000; 
  print("histogram:  %d.%d msec\n",t1/10,t1-10*(t1/10));
  }


/* jpeg encoding ********************************************************/

  {
  U8 *addr = (U8 *)vcmalloc(0x60000);

  wedge(&a);

  t0 = getvar(MSEC);

  for(i=0; i<10; i++)
    cjpeg_d(&a, 80, addr, 0x60000);

  t1 = getvar(MSEC) - t0;
  if (t1 < 0) t1 += 1000; 

  print("jpeg encoding:  %d.%d msec\n",t1/10,t1-10*(t1/10));

/* jpeg decoding ********************************************************/


  t0 = getvar(MSEC);

  for(i=0; i<10; i++)
    djpeg_d(&a, addr);

  t1 = getvar(MSEC) - t0;
  if (t1 < 0) t1 += 1000; 

  print("jpeg decoding:  %d.%d msec\n",t1/10,t1-10*(t1/10));

  vcfree(addr);
  }



sysfree((void *)d.st);
sysfree((void *)b.st);

}



/* EOF */
