/*******************************************************************/

/*

Demo-Software for smart cameras from Vision Components
------------------------------------------------------

Program: Michael Steinel,  VC


Program Description:
--------------------

ftpclient recording images into the RAM memory and transfer it to a remote FTP server.

*/

/*******************************************************************/

#include <vcrt.h>
#include <vclib.h>
#include <flib.h>
#include <macros.h>
#include <sysvar.h>

int main()
{
  unsigned int length = 50000;
  image iScreen;
  int  nr = 0;
  int  nResult = 0;
  char cmd[256];
  char cFileName[28];
  FILE * fd_data  = NULL;
  //FILE * fd_ctrl  = NULL; // handy to have no output
  FILE * fd_ctrl  = (FILE *)io_get_handle(IO_STDOUT); // print ctrl messages to stdout
  ip_address ip   = 0xc0a8002a; // FTP server IP 192.168.0.42
  pointer handle  = 0;          // FTP session handle
  U8 * buf;
  uint_32 bufsize;

  static FTP_DIRECT_STRUCT ds;

  //!!!!! init license here !!!!!!!!

  buf = sysmalloc(length/4,0);
  
  if(!buf) return -1;

  bufsize = length;

  nResult = FTP_open(&handle,ip,fd_ctrl);                   //connect
  if(nResult == -1) return -1;
  nResult = FTP_command(handle,"USER testftp\r\n",fd_ctrl); //authenticate user 'testftp'
  if(nResult == -1) return -1;
  nResult = FTP_command(handle,"PASS testftp\r\n",fd_ctrl); //with password     'testftp'
  if(nResult == -1) return -1;
  nResult = FTP_command(handle,"TYPE I\r\n",fd_ctrl);       //set binary transfer mode
  if(nResult == -1) return -1;

  ScrSetLogPage (ScrGetPhysPage);

  ImageAssign (&iScreen, ScrByteAddr (0,0), ScrGetColumns, ScrGetRows, ScrGetPitch);

  tpict();

  do
  {
	nr++;
	io_sprintf(cFileName,"%s%d%s","pt",nr,".jpg");
	
	print ("nr: %4d  - file: %s\n", nr, cFileName);
	
	tpict();

	ds.buffer = (char *)buf;
	ds.length = cjpeg(&iScreen, 80, buf, bufsize, NULL) - buf;

	fd_data = (FILE_PTR)(&ds);

	sprintf(cmd,"STOR %s\r\n",cFileName);
	
	if(!fd_data) return -1;
	
	nResult = FTP_command_data( handle, cmd, fd_ctrl, fd_data, FTPMODE_PASV | FTPDIR_SEND | FTPDIRECT_MEM ); 
	
	if ((rbempty()!=-1) || (nResult == -1))
	{
	  print("res=0x%x\n", nResult);
	  break;
	}
  } while (1);

  nResult = FTP_close(handle,fd_ctrl);

  sysfree(buf);

  return 0;
}
/*******************************************************************/
