/*HEADER*******************************************************************
***************************************************************************
***
*** Copyright (c) 2002 Vision Components
***
*** All rights reserved
***
*** This software embodies materials and concepts which are confidential
*** to Vision Components
***
*** File: qotdsrv.c
***                                                            
*** Comments: Example quote of the day server using TCP/IP Library.
***
*** Revision History:
***    Date          Version    Author  Changes
***    Aug 07, 2002  0.00       ME      Initial Version
***
***************************************************************************
*END***********************************************************************/

#include <string.h>
#include <vcrt.h>
#include <sysvar.h>


void Main_task (unsigned);


char * Quotes[] = 
{
 "Anyone who has never made a mistake has never tried anything new.",
 "The only way to discover the limits of the possible, "
 "\nis to go beyond them into the impossible.",
 "Good is the enemy of best",
 "Repetition teaches the Donkey",
 "Check the task stack sizes!",
 "Give a man a fish and he can eat for a day.  "
 "Teach a man to fish and he can eat for a lifetime.",
 "Expect the best, prepare for the worst",
 "Man who sitteth on upturned tack shall surely rise",
 "Don't use an axe to remove a fly from a friend's forehead",
 "Einmal ist keinmal",
 "Carpe diem",
 "The art of navigation is knowing where you are not",
 "Success is 99 percent failure",
 "Brevity is the soul of wit",
 "Neither a borrower, nor a lender be", 
 "Get thee to a nunnery",
 "Something is rotten in the state of Denmark",
 "There are more things in heaven and earth, Horatio "
 "than are dreamt of in your philosophy.",
 "Though this be madness, yet there is method in't",
 "This above all: to thine own self be true"
 "\nAnd it must follow, as the night the day,"
 "\nThou canst not then be false to any man.",
 "What's in a name? that which we call a rose"
 "\nBy any other name would smell as sweet.",
 "From 2001: Open the pod bay doors, Hal.",
 "Apollo 13: Houston, we have a problem.",
 "Back to the Future: Where we're going we don't need roads.",
 "Forest Gump: Life is like a box of chocolates.",
 "Star Wars: May the Force be with you.",
 "Star Trek: Live long and prosper. Engage!",
 "Peter Pan: Second star on the right, straight on 'til morning.",
 "Terminator 2: Hasta la vista, baby.",
 "The Wizard of Oz: Toto, I have a feeling we're not in Kansas anymore.",
 "Dr. McCoy: Damn it Jim, I'm a doctor, not an engineer!",
 "Winston Churchill:"
 "\nHe has all of the virtues I dislike and none of the vices I admire.",
 "Einstein: Everything should be made as simple as possible, but not simpler.",
 "Whether you think you can or think you can't -- you are right.",
 "Traffic is very heavy at the moment, so if you are thinking of leaving, "
 "you'd better set off a few minutes earlier.", 
 "Yogi Berra: Always go to other people's funerals, "
 "otherwise they won't come to yours.",
 NULL            /* End of quotes marker */
};



void main(int argc, char *argv)
{
   sockaddr_in    laddr, raddr;
   unsigned       sock, listensock;
   int            length;
   unsigned       index;
   unsigned       error;
   uint_16        rlen;

   /* Quote server services port 17 */
   laddr.sin_family      = AF_INET;
   laddr.sin_port        = 17;
   laddr.sin_addr.s_addr = INADDR_ANY;


    /* Listen on TCP port */
   sock = socket_stream();
   if (sock == VCRT_HANDLE_ERROR) 
     {
     print("\nCreate stream socket failed");
     return;
     } 
     
   error = bind(sock, &laddr, sizeof(laddr));

   if (error != VCRT_OK) 
     {
     print("\nStream bind failed - 0x%x", error);
     return;
     }

   error = listen(sock, 0);

   if (error != VCRT_OK) 
     {
     print("\nListen failed - 0x%x", error);
     return;
     }

   listensock = sock;

   print("\n\nQuote Server active on port 17\n");

   index = 0;
   for (;;) {

      sock = VCRT_selectall(0);

      if (sock == listensock)
        {

        /* Connection requested; accept it */
        rlen = sizeof(raddr);
        sock = accept(listensock, &raddr, &rlen);
        if (sock == VCRT_HANDLE_ERROR)
          {
          print("\nAccept failed, error 0x%x",VCRT_geterror(listensock));
          continue;
          }
          print("\nConnection from %d.%d.%d.%d, port %d",
           (raddr.sin_addr.s_addr >> 24) & 0xFF,
           (raddr.sin_addr.s_addr >> 16) & 0xFF,
           (raddr.sin_addr.s_addr >>  8) & 0xFF,
            raddr.sin_addr.s_addr        & 0xFF,
            raddr.sin_port);

        send(sock, Quotes[index], strlen(Quotes[index]) + 1, 0);

        wait(0,1000);
        shutdown(sock, FLAG_CLOSE_TX);

        }
      else
        {

        }

      ++index;
      if (Quotes[index] == NULL)
        {
        index = 0;
        }

   } /* Endfor */

} /* Endbody */


/* EOF */
