/*******************************************************************/
/*

Demo-Software for smart cameras from Vision Components
------------------------------------------------------

Program: Klaus Schneider,  VC


Program Description:
--------------------

FOR VC/RT 5.X
This program calls a new program (prg1) with the function exec().
If the function prg1 is not available on the flash eprom,
it causes a soft reset of the camera. You will lose all global 
variables after the exec() function. The local variables are 
still there.

06/07/07 : updated to exec3() LB

*/
/*******************************************************************/

#include <vcrt.h>
#include <vclib.h>
#include <macros.h>
#include <sysvar.h>

/*******************************************************************/

void CallPrg (char *prg);

/*******************************************************************/

void main(void)

  {
  CallPrg("fd:/prg1.exe");
  }

/*******************************************************************/

void CallPrg (char *prg)
  {
  FILE *fp;
  int ivar1  = 100;
  int ivar2  = 10000;				/* all variables must be 32 bit	*/
  int Priority = 9;                 /* Priority 9 */
  int Timeslice = 10;               /* Timeslice 10ms (standard value) */

  /* check, if program is on the flash */

  if(!(fp =io_fopen(prg,"c")))
    {
    pstr("\nprogram not available: ");
    pstr(prg);
    }
  else
    {
    io_fclose(fp);
    exec3(Priority, Timeslice, prg, ivar1, ivar2);
    }

  print("\nVariables from calling function: ivar1 = %d ivar2 = %d",ivar1,ivar2);
  }

/*******************************************************************/



