/*******************************************************************/
/*

Demo-Software for smart cameras from Vision Components
------------------------------------------------------

Program: Klaus Schneider,  VC


Program Description:
--------------------

Demo for parallel processes.

The program echo.c is waiting for characters coming from the program
key.c. The program key.c stores characters in the system variable
input (PRIVATE+0). The program echo.c works parallel to key.c and 
echos the system variable input (PRIVATE+0) to the system variable
output (PRIVATE+1). The program key.c prints out the system variable
output (PRIVATE+1).

Start the program echo with the shell command 'echo &'. 
Then start parallel the program key (shell command 'key').
Both programs are running in parallel. The program key.c is
waiting for a key and prints out the result of the key.
With 'q' you can quit both programs.

*/
/*******************************************************************/

#include <vcrt.h>
#include <vclib.h>
#include <macros.h>
#include <sysvar.h>

/*******************************************************************/

void main(void)
{
  int  value, input, output;

  /* 50 free system variables for customer purpose (0 - 49) */
  input =getvar(PRIVATE)+0;
  output=getvar(PRIVATE)+1;

  do
  {
    value=getvar(input);

    if (value) 
    {
      setvar(output, value);
      setvar(input,  0);
    }

    /* necessary to allow other programs to run */
    time_delay(1);
  }
  while(value != 'q');
}

/*******************************************************************/

