/*******************************************************************/
/*

Demo-Software for smart cameras from Vision Components
------------------------------------------------------

Program: Klaus Schneider,  VC


Program Description:
--------------------

FOR VC/RT 5.X
Program does a wait(TRIG_READY,timeout); to get a picture taken event

You have to use at least VCRT 5.18 !!!

Start this task from main program with exec(), exec2() or exec3()


*/
/*******************************************************************/

#include <vcrt.h>
#include <vclib.h>
#include <macros.h>
#include <sysvar.h>

/*******************************************************************/

#define YOUR_EVENT getvar(USR_EVENT)

int main()
{
    int x,timeout = 15000; // timeout in ms
    static unsigned int tcount = 100;
    /*
     *  tcounter should be a private sysvar
     *  to access the counter from main program!!! 
     */
    static unsigned int tcounter;

    TRIG_INT_DISABLE();
    print("TRIG_INT disabled\n");

    tcounter = tcount;
    print("TRIGCOUNTER= %u (init)\n",tcounter);

    print("TIMEOUT: %u\n",timeout);
    
    // event_connect_to_task(); 	// make events availabale for task, not needed for VCRT > 5.26

    print("TRIG_INT enabled\n");
    TRIG_INT_ENABLE();


    while(1) 
    {
	    x = wait(TRIG_READY, timeout); // wait for event TRIG_READY (trigger impulse occured)

	    switch(x)
	    {
		    case 1:
		    case 2:
			    tcounter--;                    // decrement counter

			    if(tcounter==0)
			    {
				    tpict();               // take picture
				    set_evt(YOUR_EVENT);   // tell the main program we have a picture
				    tcounter = tcount;     // set new trigger counter value
			    }

                            if(x==1)
				    print("event occured\n");
			    else
				    print("event occured before wait was called\n");

			    break;
		    case -1:
			    print("event timed out\n");

	    }
	    print("TRIGCOUNTER: %u\n",tcounter);
    }
     
    // never reached

    TRIG_INT_DISABLE();
    print("TRIG_INT disabled\n");

    //event_disconnect(); 	// disconnect event from task, not needed for VCRT > 5.26

    return(0);
}



