/*******************************************************************/
/*

Demo-Software for smart cameras from Vision Components
------------------------------------------------------

Program: Peter Neuhaus,  VC


Program Description:
--------------------

Example of using image capture events.

*/
/*******************************************************************/

#include <vcrt.h>
#include <vclib.h>
#include <macros.h>
#include <sysvar.h>
#include <flib.h>
#include <licence.h>
 

/*******************************************************************/

void main(void)
{
  int ms=0, ms1, ms2, ms3, ms4, ms5, tc_rq, texp, ttr, ttot, a, b, c, d;
  int TrackNr[3];
  int key = 0, ImgNr ;
    
    /*******************************************************************************/
    /*                 PLEASE INITIALIZE YOUR LICENCE CODES                        */
    /*                    To activate library functions                            */
    /*                                                                             */
    /* VCLIB :         init_licence("T1234567890") or init_licence("LT1234567890") */
    /* Extension Lib : init_licence("E1234567890") or init_licence("LE1234567890") */
    /* Color Lib :     init_licence("C1234567890") or init_licence("LC1234567890") */
    /* etc.                                                                        */
    /*                                                                             */
    /*      init_licence() returns 0 if licence code is OK, -5 otherwise           */
    /*                                                                             */
    /* Example :                                                                   */
    /*                                                                             */
	/**/ 	print("Init VCLIB = %d\n", init_licence("T1122334455"));			 /**/
    /*******************************************************************************/

  print("\ntake image with 'tpict' and read out \n'wait(EXP_READY, 100)' and 'wait(IMAGE_READY, 100)' twice\n\n");
  getchar(); //wait for keyboard input
  
  tpict();

  a= wait(EXP_READY, 100);
  b= wait(IMAGE_READY, 100);
  c= wait(EXP_READY, 100);
  d= wait(IMAGE_READY, 100);

  print("1.'wait(EXP_READY,100)'   = %d\n",a);
  print("1.'wait(IMAGE_READY,100)' = %d\n",b);
  
  print("2.'wait(EXP_READY,100)'  = %d\n",c);
  print("2.'wait(IMAGE_READY,100)'= %d\n\n",d); 


  print("\ntake image using 'capture_request' and read out \n'wait(EXP_READY,100)' and 'wait(IMAGE_READY,100)' twice\n\n");
  getchar(); //wait for keyboard input

  capture_request(getvar(EXPCNT), getvar(GAIN),(int*)ScrGetCaptPage,0);

  a= wait(EXP_READY, 100);
  b= wait(IMAGE_READY, 100);
  c= wait(EXP_READY, 100);
  d= wait(IMAGE_READY, 100);

  print("1.'wait(EXP_READY,100)'   = %d\n",a);
  print("1.'wait(IMAGE_READY,100)' = %d\n",b);
  
  print("2.'wait(EXP_READY,100)'  = %d\n",c);
  print("2.'wait(IMAGE_READY,100)'= %d\n\n",d); 


  ////////////////////////////////////
  // 1. image aquisition with tpict //
  ////////////////////////////////////

 	 	ms = getvar(MSEC);
  tpict();  
 	 	ms = getvar(MSEC)-ms;
  		if(ms<0) ms+=1000;

  print("tpict = shutter speed + transfer time t=%dms\n",ms);
  

  print("\nPress any key - \n "); getchar();

  //////////////////////////////////////////////////////////////////////
  // 2. image aquisition with capture_request polling tracking number //
  //////////////////////////////////////////////////////////////////////
        


 		 ms1 = getvar(MSEC);
  TrackNr[0] = capture_request(getvar(EXPCNT), getvar(GAIN),(int*)ScrGetCaptPage,0);
 		 ms2 = getvar(MSEC);
  while(TrackNr[0]== getvar(EXPOSING));
 		 ms3 = getvar(MSEC);
  while(TrackNr[0] == getvar(STORING));
 		 ms4 = getvar(MSEC);
  while(TrackNr[0] != getvar(IMGREADY));
 		 ms5 = getvar(MSEC);

  		tc_rq = ms2 - ms1;
  		if (tc_rq<0) tc_rq+=1000;
  
  		texp = ms3 - ms2;
  		if (texp<0) texp+=1000;

  		ttr = ms4 -ms3;
 		 if (ttr<0) ttr+=1000;
  
  		ttot = ms5- ms1;
  		if (ttot<0) ttot+=1000;

  print("tc_rq = %d, texp = %d,  ttr = %d, ttot = %d \n", tc_rq, texp, ttr, ttot);



 ///////////////////////////////////////////////////////////
 // 3. image aquisition loop using getvar(IMGREADY)       //
 ///////////////////////////////////////////////////////////


  print("\nPress any key to start image loop polling \n Press 'q' to stop \n"); getchar();

      do
        {
         if (kbhit())
		     {
			 key = rs232rcv();
			 }
            
           ImgNr = capture_request(getvar(EXPCNT), getvar(GAIN),(int*)ScrGetCaptPage,0);

            while(ImgNr != getvar(IMGREADY));    

        }
	 while(key != 'q');

     key = 'a';

//////////////////////////////////////////////////////////////////////
 // 4. image aquisition loop using events  wait(IMAGE_READY, 100)); //
 /////////////////////////////////////////////////////////////////////


  print("\nPress any key to start image loop using events \n Press 'q' to stop \n"); getchar();

      do
        {
         if (kbhit())
		     {
			 key = rs232rcv();
			 }

           capture_request(getvar(EXPCNT), getvar(GAIN),(int*)ScrGetCaptPage,0);
        
           while(wait(IMAGE_READY, 100) != 1);
        }
	 while(key != 'q');


   vmode(vmLive);

}

/*******************************************************************/

