/************************************************************************************/
/*

Demo-Software for smart cameras from Vision Components
------------------------------------------------------

Program Description:
--------------------

Example for packing flash EEPROM.
Do not pack flash too often, to preserve flash durability.


Revision History:
-----------------

   Date           Version    Author  Changes
   Nov 20, 2008   1.00       LB      Initial Version

*/
/************************************************************************************/

#include <vcrt.h>
#include <vclib.h>
#include <flib.h>
#include <macros.h>
#include <register.h>
#include <sysvar.h>

#define MIN_FREE_SPACE_BEFORE_PACK 500000

/************************************************************************************/

void main(void)
{
	U32 result, size;
	FILE *fp;

	// Open device fd: in control mode
  	fp = io_fopen("fd:","c");

  	if(fp)
    	{
		// Check for remaining flash space
		io_ioctl(fp, IO_REMAIN, &size);
		print("Remaining flash space : %d\n", size);
			
		// Pack only if available free space gets too small
		if(size < MIN_FREE_SPACE_BEFORE_PACK)
			{
			print("Pack flash : %d\n", io_ioctl(fp, IO_PACK, &result));
			}
		else
			{
			print("%d bytes are still available, no need to pack\n", size);
			}

		// Close device
    	io_fclose(fp);
    	}
  	else
   		{
   		print("Error in opening device\n");
   	 	}
}

/************************************************************************************/

