/*HEADER*******************************************************************
***************************************************************************
***
*** Copyright (c) 2005 Vision Components
***
*** All rights reserved
***
*** This software embodies materials and concepts which are confidential
*** to Vision Components
***
*** File: color2.c
***                                                            
*** Comments: 
*** 
***    Demoprogram for the usage of color image variables
***	   program saves a .bmp file to md: or loads it from md:
***
*** Revision History:
***    Date          Version    Author  Changes
***    Nov 23, 2005  3.01       ME      Initial Version
***
***************************************************************************
*END***********************************************************************/

#define NEW_IMAGE_VAR			/* important for color image variables	*/

#include <sysvar.h>
#include <vcrt.h>
#include <vclib.h>
#include <flib.h>
#include <macros.h>

/**************************************************************************/

void main(void)
{
	image rgb, b;
	U32 old_start;
	U32 old_mode;
	char c;

    /*******************************************************************************/
    /*                 PLEASE INITIALIZE YOUR LICENCE CODES                        */
    /*                    To activate library functions                            */
    /*                                                                             */
    /* VCLIB :         init_licence("T1122334455") or init_licence("LT1122334455") */
    /* Extension Lib : init_licence("E1122334455") or init_licence("LE1122334455") */
    /* Color Lib :     init_licence("C1122334455") or init_licence("LC1122334455") */
    /* etc.                                                                        */
    /*                                                                             */
    /*      init_licence() returns 0 if licence code is OK, -5 otherwise           */
    /*                                                                             */
    /* Example :                                                                   */
    /*                                                                             */
	/**/ 	print("Init VCLIB = %d\n", init_licence("T1122334455"));			 /**/
	/**/ 	print("Init Color Lib = %d\n", init_licence("C1122334455"));         /**/
    /*******************************************************************************/


	print("save / load a bitmap file\n");
	rs232rcv();

	ImageAllocate(&rgb, IMAGE_RGB, 768, 582);		/* allocate RGB color image				*/
	rgb.dx = 752;									/* set dx to 752						*/

	cset(&rgb, 0, 0, 128);							/* set screen to medium blue			*/

	old_start = getvar(DISP_START);					/* save old start address				*/
	old_mode  = getvar(COLOR_MODE);					/* save old color mode					*/

	setvar(DISP_START, (int)rgb.st);				/* set DISP_START to start of			*/
													/* image variable						*/

	setvar(COLOR_MODE, DISP_RGB);					/* set appropriate color display mode	*/

	/* assign parameters for capture screen to image variable b								*/

	ImageAssignC(&b, getvar(CAPT_START), IMAGE_BAYER,
			getvar(HWIDTH), getvar(VWIDTH), getvar(VPITCH), (U8 *)0, (U8 *)0);

	print("enter mode s=save l=load\n");
	c = rs232rcv();

	if(c == 's')
	  {
	  tpict();										/* take picture							*/
	  BayerToRGB(&b, &rgb);
	  fwrite_image("md:/rgb.bmp", &rgb);
	  }

	if(c == 'l')
	  fread_image("md:/rgb.bmp", &rgb);


	print("ready:\n");
	rs232rcv();

	ImageFree(&rgb);								/* release memory for color image		*/

	setvar(DISP_START, old_start);					/* restore old start address			*/
	setvar(COLOR_MODE, old_mode);					/* restore old color mode				*/  
}

/* EOF */
