/*HEADER*******************************************************************
***************************************************************************
***
*** Copyright (c) 2005 Vision Components
***
*** All rights reserved
***
*** This software embodies materials and concepts which are confidential
*** to Vision Components
***
*** File: color4_nodisp.c
***                                                            
*** Comments: 
*** 
***    Demoprogram for the usage of color image variables
***	   program saves a .bmp file to fd: or loads it from fd:
***	   Version for cameras without video output
***
*** Revision History:
***    Date          Version    Author  Changes
***    Nov 23, 2005  3.01       ME      Initial Version
***    May 15, 2009  3.07		LB		Modified for cameras without display
***
***************************************************************************
*END***********************************************************************/

#define NEW_IMAGE_VAR			/* important for color image variables	*/

#include <sysvar.h>
#include <vcrt.h>
#include <vclib.h>
#include <flib.h>
#include <macros.h>

/**************************************************************************/

void main(void)
{
	image rgb, b;
	char c;

    /*******************************************************************************/
    /*                 PLEASE INITIALIZE YOUR LICENCE CODES                        */
    /*                    To activate library functions                            */
    /*                                                                             */
    /* VCLIB :         init_licence("T1122334455") or init_licence("LT1122334455") */
    /* Extension Lib : init_licence("E1122334455") or init_licence("LE1122334455") */
    /* Color Lib :     init_licence("C1122334455") or init_licence("LC1122334455") */
    /* etc.                                                                        */
    /*                                                                             */
    /*      init_licence() returns 0 if licence code is OK, -5 otherwise           */
    /*                                                                             */
    /* Example :                                                                   */
    /*                                                                             */
	/**/ 	print("Init VCLIB = %d\n", init_licence("T1122334455"));			 /**/
	/**/ 	print("Init Color Lib = %d\n", init_licence("C1122334455"));         /**/
    /*******************************************************************************/


	print("save / load a bitmap file\n");
	rs232rcv();
	
	// allocate RGB color image
	ImageAllocate(&rgb, IMAGE_RGB, ScrGetColumns, ScrGetRows);
	cset(&rgb, 0, 0, 128);			/* set screen to medium blue */

	// If VC4016 or SBC4016, first red pixel one line below
	if (getvar(MODEL) == 4016)
		BayerStart = (U8*)(ScrGetCaptPage + ScrGetPitch);
	else
		BayerStart = (U8*)(ScrGetCaptPage);

	// assign parameters for capture screen to image variable b
	ImageAssignC(&b, BayerStart, IMAGE_BAYER,
			ScrGetColumns, ScrGetRows, ScrGetPitch, (U8 *)0, (U8 *)0);

	print("enter mode s=save l=load\n");
	c = rs232rcv();

	if(c == 's')
	  {
	  tpict();								/* take picture	*/
	  BayerToRGB(&b, &rgb);
	  fwrite_image("fd:/rgb.bmp", &rgb);
	  }

	if(c == 'l')
	  fread_image("fd:/rgb.bmp", &rgb);


	print("ready:\n");
	rs232rcv();

	ImageFree(&rgb);						/* release memory for color image		*/
 
}

/* EOF */
