/*HEADER*******************************************************************
***************************************************************************
***
*** Copyright (c) 2006 Vision Components
***
*** All rights reserved
***
*** This software embodies materials and concepts which are confidential
*** to Vision Components
***
*** File: polar.c
***                                                            
*** Comments: 
*** 
***    example for use of polar transform
***
***   Arguments of polar_image_transform()
***	src	  		  : pointer to source image
***	dst	 		  : pointer to destination image
***	t[2]		  	: inverse 2D translation vector (origin of the polar referential)
***    r0			  : minimum radius for transform
***
*** Revision History:
***    Date          Version    Author  Changes
***    Oct 22, 2009  3.07       ME      initial version
***
***************************************************************************
*END***********************************************************************/

#define NEW_IMAGE_VAR

#include <vcrt.h>
#include <vclib.h>
#include <macros.h>
#include <sysvar.h>
#include <flib.h>

/*******************************************************************/


void main(void)
{
	image Src, img;

	int time;
	float t[2];

	/////////////////////////////////////////////////////////////////////////////////////
	// initialize licence key 
	/////////////////////////////////////////////////////////////////////////////////////

    /*******************************************************************************/
    /*                 PLEASE INITIALIZE YOUR LICENCE CODES                        */
    /*                    To activate library functions                            */
    /*                                                                             */
    /* VCLIB :         init_licence("T1122334455") or init_licence("LT1122334455") */
    /* Extension Lib : init_licence("E1122334455") or init_licence("LE1122334455") */
    /* Color Lib :     init_licence("C1122334455") or init_licence("LC1122334455") */
    /* etc.                                                                        */
    /*                                                                             */
    /*      init_licence() returns 0 if licence code is OK, -5 otherwise           */
    /*                                                                             */
    /* Example :                                                                   */
    /*                                                                             */
	/**/ 	print("Init VCLIB = %d\n", init_licence("T1122334455"));			 /**/
	/**/ 	print("Init Extension Lib = %d\n", init_licence("E1122334455"));     /**/
    /*******************************************************************************/

	print("Taking picture...\n");
	tpict();

	printf("Polar Transform\n");

	ImageAssign(&Src, getvar(CAPT_START), ScrGetColumns, ScrGetRows, ScrGetPitch);
	ImageAllocate(&img, IMAGE_GREY, ScrGetColumns, ScrGetRows);

	//printf("img start = %08x\n", (U32)img.st);

	print("Press a key to display center\n");
	rs232rcv();

	copy(&Src, &img);

	t[0] = 512.0;
	t[1] = 384.0;

	MarkCross(&Src, (I32)t[0], t[1], 255, 16);

	print("Press a key to do polar transform\n");
	rs232rcv();
	time = getvar(MSEC);

	printf("result = %d\n", polar_image_transform(&img, &Src, t, 0, 0));
	print("time elapsed: %d msec\n", getvar(MSEC)-time < 0 ? getvar(MSEC)-time+1000 : getvar(MSEC)-time);

	rs232rcv();

	ImageFree(&img);
}

