/*HEADER*******************************************************************
***************************************************************************
***
*** Copyright (c) 2006 Vision Components
***
*** All rights reserved
***
*** This software embodies materials and concepts which are confidential
*** to Vision Components
***
*** File: dilate.c
***                                                            
*** Comments: 
*** 
***    demoprogram: binary image processing
***    RLC erosion / dilation
***
*** Revision History:
***    Date          Version    Author  Changes
***    Jan 17, 2006  3.01       ME      Initial Version
***
***************************************************************************
*END***********************************************************************/

#define NEW_IMAGE_VAR

#include <vcrt.h>
#include <vclib.h>
#include <stdlib.h>
#include <macros.h>
#include <register.h>
#include <sysvar.h>

#define LENGTH	0x80000		/* maximum length for RLC	*/

/**************************************************************************/

void main(void)
{
	char c;
	image a;
	U16 *rlc, *rlc2;

    /*******************************************************************************/
    /*                 PLEASE INITIALIZE YOUR LICENCE CODES                        */
    /*                    To activate library functions                            */
    /*                                                                             */
    /* VCLIB :         init_licence("T1122334455") or init_licence("LT1122334455") */
    /* Extension Lib : init_licence("E1122334455") or init_licence("LE1122334455") */
    /* Color Lib :     init_licence("C1122334455") or init_licence("LC1122334455") */
    /* etc.                                                                        */
    /*                                                                             */
    /*      init_licence() returns 0 if licence code is OK, -5 otherwise           */
    /*                                                                             */
    /* Example :                                                                   */
    /*                                                                             */
	/**/ 	print("Init VCLIB = %d\n", init_licence("T1122334455"));			 /**/
    /*******************************************************************************/


	/* set image variable to size of screen	*/
	ImageAssign(&a, (U8 *)getvar(CAPT_START), getvar(HWIDTH), getvar(VWIDTH), getvar(VPITCH));

	/* allocate memory for RLC				*/
	rlc=rlcmalloc(LENGTH);


	/* print menu							*/
	pstr("erosion / dilation demoprogram\n");

	pstr("type:\n");
	pstr("erode square ..............1\n");
	pstr("dilate square .............2\n");
	pstr("erode diamond .............3\n");
	pstr("dilate diamond ............4\n");
	pstr("exit ......................e\n");

	/* Take picture */
	tpict();

	/* main loop							*/
	while(1)
	  {

	  if((rlc2=rlcmk(&a, 128, rlc, LENGTH)) != 0)		/* create RLC			*/
	    {
	    rlcout(&a, rlc, 0, 255);						/* output binary image	*/
		}
	  else
	    {
		print("error creating RLC. ABORT!\n");
		break;
		}

	  c=rs232rcv();

	  switch (c)
	    {
	    case '1':     erode(rlc, rlc2);     break;
	    case '2':     dilate(rlc, rlc2);    break;
	    case '3':     erode2(rlc, rlc2);    break;
	    case '4':     dilate2(rlc, rlc2);   break;
	    case 'e':     goto exit_pgm;		break;
	    default:      erode(rlc, rlc2);		break;
	    }


	  rlcout(&a, rlc2, 0, 255);							/* output binary image	*/
	  }


	exit_pgm:
	rlcfree(rlc);										/* release RLC memory	*/
}


/* EOF */
