/*HEADER*******************************************************************
***************************************************************************
***
*** Copyright (c) 2007 Vision Components
***
*** All rights reserved
***
*** This software embodies materials and concepts which are confidential
*** to Vision Components
***
*** File: imsave.c
***                                                            
*** Comments: 
*** 
***    select window and save as bitmap
***
*** Revision History:
***    Date          Version    Author  Changes
***    Jan 19, 2007  3.02       ME      Initial Version
***
***************************************************************************
*END***********************************************************************/

#define NEW_IMAGE_VAR
#include <vcrt.h>
#include <vclib.h>
#include <flib.h>
#include <macros.h>
#include <stdlib.h>
#include <register.h>
#include <sysvar.h>
#include <math.h>
#include <mathf.h>




main()
{
  image save, ovl, buf, frame;
  I32 vsize = 160;
  I32 hsize = 160;
  char response;
  I32 line=0, row=0;

    /*******************************************************************************/
    /*                 PLEASE INITIALIZE YOUR LICENCE CODES                        */
    /*                    To activate library functions                            */
    /*                                                                             */
    /* VCLIB :         init_licence("T1122334455") or init_licence("LT1122334455") */
    /* Extension Lib : init_licence("E1122334455") or init_licence("LE1122334455") */
    /* Color Lib :     init_licence("C1122334455") or init_licence("LC1122334455") */
    /* etc.                                                                        */
    /*                                                                             */
    /*      init_licence() returns 0 if licence code is OK, -5 otherwise           */
    /*                                                                             */
    /* Example :                                                                   */
    /*                                                                             */
	/**/ 	print("Init VCLIB = %d\n", init_licence("T1122334455"));			 /**/
    /*******************************************************************************/

  ImageAssign(&save, getvar(DISP_START), getvar(DHWIDTH),  getvar(DVWIDTH),  getvar(VPITCH));
  ImageAssign(&ovl,  getvar(OVLY_START), getvar(DHWIDTH),  getvar(DVWIDTH),  getvar(VPITCH));
  
  ImageAssign(&frame, getvar(DISP_START), getvar(DHWIDTH),  getvar(DVWIDTH),  getvar(VPITCH));
  ImageAllocate(&buf,  IMAGE_GREY,   hsize, vsize);


  set_ovlmask(0xff);
  set_overlay_bit(7,255,255,0); /* yellow   */
  set(&ovl, 0);   				/* clear overlay                        */
  
 
  
  print("select and save image vs. 1.0:\n");
  print("Vision Components      2007 (c)\n\n");
  
 
  print("the following commands are available:\n\n");
  print("down ................................ d\n");
  print("up .................................. u\n");
  print("right ............................... r\n");
  print("left ................................ l\n");
  print("save ................................ s\n");
  print("quit .............................. ESC\n");

  ImageAssign(&save, getvar(DISP_START) + row + (line * getvar(VPITCH)), hsize,  vsize,  getvar(VPITCH));
  ImageAssign(&ovl,  getvar(OVLY_START) + row + (line * getvar(VPITCH)), hsize,  vsize,  getvar(VPITCH));
  
  dframex(&ovl, 255);
  
  
    do
      {

      if (kbhit())                     
        {
        response=ReadKeyboard(1);
  
        if (response == 'u')  line--;
        if (response == 'U')  line -= 10;
  
        if (response == 'd')  line++;
        if (response == 'D')  line += 10;

        if (response == 'l')  row--;
        if (response == 'L')  row -= 10;

        if (response == 'r')  row++;
        if (response == 'R')  row += 10;

	    line = (line < 0) ? 0 : line;
	    line = (line > (getvar(VWIDTH)-vsize)) ? (getvar(VWIDTH)-vsize) : line;
	    row  = (row  < 0) ? 0 : row;
	    row  = (row  > (getvar(HWIDTH)-hsize)) ? (getvar(HWIDTH)-hsize) : row;

		dframex(&ovl, 255);

        ImageAssign(&save, getvar(DISP_START) + row + (line * getvar(VPITCH)), hsize,  vsize,  getvar(VPITCH));
        ImageAssign(&ovl,  getvar(OVLY_START) + row + (line * getvar(VPITCH)), hsize,  vsize,  getvar(VPITCH));


		dframex(&ovl, 255);


        if (response == 's') fwrite_image("md:/save.bmp", &save) ;
        if (response == 'S') 
           {
		   copy(&save, &buf);
		   set(&frame, 0);
		   copy(&buf, &save);
           fwrite_image("md:/save.bmp", &frame) ;
		   }

        }

      }
    while(response != KEY_ESC);
    

  ImageFree(&buf);
 
}




/* EOF */
