/*******************************************************************/
/*

Demo-Software for smart cameras from Vision Components
------------------------------------------------------

Program: Klaus Schneider,  VC


Program Description:
--------------------

The program reduce the size of an image (Original) by RH and
RV (reduce factor horizontal and vertical) and stores the
result in the image Copy. On the image Copy it use a sobel
operator.

*/
/*******************************************************************/

#include <vcrt.h>
#include <vclib.h>
#include <macros.h>
#include <sysvar.h>

/*******************************************************************/

#define   RH  2  /* reduce factor horizontal   (RH >= 2)   */
#define   RV  2  /* reduce factor vertical     (RV >= 1)   */

/*******************************************************************/

void main(void)

  {
  int   Image1, Overlay1, time;
  image Original, Copy;

    /*******************************************************************************/
    /*                 PLEASE INITIALIZE YOUR LICENCE CODES                        */
    /*                    To activate library functions                            */
    /*                                                                             */
    /* VCLIB :         init_licence("T1122334455") or init_licence("LT1122334455") */
    /* Extension Lib : init_licence("E1122334455") or init_licence("LE1122334455") */
    /* Color Lib :     init_licence("C1122334455") or init_licence("LC1122334455") */
    /* etc.                                                                        */
    /*                                                                             */
    /*      init_licence() returns 0 if licence code is OK, -5 otherwise           */
    /*                                                                             */
    /* Example :                                                                   */
    /*                                                                             */
	/**/ 	print("Init VCLIB = %d\n", init_licence("T1122334455"));			 /**/
    /*******************************************************************************/

  /* get the actual values for the screen and overlay address */   
  Image1   = ScrGetPhysPage;
  ScrSetPhysPage(Image1);
  Overlay1 = OvlGetPhysPage;

  /* Working Page */
  ScrSetLogPage(Image1);
  OvlSetLogPage(Overlay1);

  /* Clear Overlay */
  OvlClearAll;

  /* Define image variables */
  ImageAssign(&Original, ScrByteAddr(0,0), ScrGetColumns, ScrGetRows, ScrGetPitch);  
  ImageAssign(&Copy,     ScrByteAddr(0,0), ScrGetColumns, ScrGetRows, ScrGetPitch); 

  print("Get Picture? (Press any Key)\n");
  rs232rcv();
  tpict();

  /* getting processor time from timer */
  time = getvar(MSEC);

  /* reduce an image by simply taken not every x and y pixel */
  subsample(&Original, &Copy, RH, RV);

  /* instead of subsample is also pyramid() possible. It takes the mean value */
  /* pyramid(&Copy, &Original); */

  /* getting processor time from timer */
  time = getvar(MSEC) - time;
  if (time<0) time += 1000;
  print("Time for calculation = %dms\n",time);

  /* Show results on the monitor */
  vmode(vmStill);

  print("Live Mode? (Press any key)\n");
  rs232rcv();
  vmode(vmLive);
  }

/*******************************************************************/


