// AtXControlCtl.cpp : Implementation of the CAtXControlCtrl ActiveX Control class.

#include "stdafx.h"
#include "atXControl.h"
#include "AtXControlCtl.h"
#include "AtXControlPpg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CAtXControlCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CAtXControlCtrl, COleControl)
	//{{AFX_MSG_MAP(CAtXControlCtrl)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_EDIT, OnEdit)
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
	ON_WM_CREATE()
//ON_WM_TIMER()
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CAtXControlCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CAtXControlCtrl)
	DISP_PROPERTY_EX(CAtXControlCtrl, "server", GetServer, SetServer, VT_BSTR)
	DISP_PROPERTY_EX(CAtXControlCtrl, "port", GetPort, SetPort, VT_I4)
	DISP_PROPERTY_EX(CAtXControlCtrl, "Busy", GetBusy, SetBusy, VT_BOOL)
	DISP_PROPERTY_EX(CAtXControlCtrl, "live", GetLive, SetLive, VT_BOOL)
	DISP_FUNCTION(CAtXControlCtrl, "RequestImage", RequestImage, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4)
	DISP_FUNCTION(CAtXControlCtrl, "SetPosition", SetPosition, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_I4)
	DISP_FUNCTION(CAtXControlCtrl, "Abort", Abort, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CAtXControlCtrl, "SaveToBmp", SaveToBmp, VT_BOOL, VTS_BSTR)
	DISP_FUNCTION(CAtXControlCtrl, "GetImgAttrib", GetImgAttrib, VT_EMPTY, VTS_PI4 VTS_PI4 VTS_PI4 VTS_PI4)
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CAtXControlCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CAtXControlCtrl, COleControl)
	//{{AFX_EVENT_MAP(CAtXControlCtrl)
	EVENT_CUSTOM("PictureReady", FirePictureReady, VTS_I4)
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CAtXControlCtrl, 1)
	PROPPAGEID(CAtXControlPropPage::guid)
END_PROPPAGEIDS(CAtXControlCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CAtXControlCtrl, "ATXCONTROL.AtXControlCtrl.1",
	0x1ab0d3d2, 0x4f4e, 0x459e, 0x8b, 0x38, 0x3d, 0xab, 0x46, 0x84, 0x4f, 0xdf)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CAtXControlCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DAtXControl =
		{ 0x1abd8116, 0x4a55, 0x4e2d, { 0x9b, 0x92, 0xf8, 0xf1, 0xd1, 0xec, 0xa7, 0xba } };
const IID BASED_CODE IID_DAtXControlEvents =
		{ 0xb93ab8b1, 0x746f, 0x4c2d, { 0xa1, 0xba, 0xc0, 0xf5, 0x54, 0x9d, 0xd, 0x48 } };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwAtXControlOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CAtXControlCtrl, IDS_ATXCONTROL, _dwAtXControlOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CAtXControlCtrl::CAtXControlCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CAtXControlCtrl

BOOL CAtXControlCtrl::CAtXControlCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegInsertable | afxRegApartmentThreading to afxRegInsertable.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_ATXCONTROL,
			IDB_ATXCONTROL,
			afxRegInsertable | afxRegApartmentThreading,
			_dwAtXControlOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CAtXControlCtrl::CAtXControlCtrl - Constructor

CAtXControlCtrl::CAtXControlCtrl()
{
	int i;
	InitializeIIDs(&IID_DAtXControl, &IID_DAtXControlEvents);

	m_port = 0;
	m_serverName = _T("");
	m_Cnt = 0;
	m_Size = 0;
	m_picX = 0;
	m_picY = 0;
	m_picDX = 0;
	m_picDY = 0;
	m_busy = FALSE;
	m_pixar = 0;
	m_pDC = 0;
	m_pBmp = 0;
	//m_pOldBmp = 0;
	m_picIX = 0;
	m_picIY = 0;
	m_bLive = FALSE;
	((CSubject *) & m_Client)->Attach((CObserver *) this);

	memset(m_bmpInfo, 0, sizeof(m_bmpInfo));
	BITMAPINFO * p = (BITMAPINFO *) m_bmpInfo;
	p->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	for(i = 0; i < 256; i ++)
	{
		p->bmiColors[i].rgbBlue = i;
		p->bmiColors[i].rgbGreen = i;
		p->bmiColors[i].rgbRed = i;
		p->bmiColors[i].rgbReserved = 0;
	}
	p->bmiHeader.biBitCount = 8;
	p->bmiHeader.biClrUsed = 0;
	p->bmiHeader.biCompression = BI_RGB;
	p->bmiHeader.biPlanes = 1;
	m_hBmp = NULL;
	m_pixmap = 0;
	// TODO: Initialize your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CAtXControlCtrl::~CAtXControlCtrl - Destructor

CAtXControlCtrl::~CAtXControlCtrl()
{
	m_Client.Close();
	((CSubject *) & m_Client)->Detach((CObserver *) this);
	if(m_pixar)
		delete[] m_pixar;
	// TODO: Cleanup your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CAtXControlCtrl::OnDraw - Drawing function

void CAtXControlCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	// TODO: Replace the following code with your own drawing code.
//	pdc->FillRect(rcBounds, CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH)));
//	pdc->Ellipse(rcBounds);

	pdc->FillRect(rcBounds, CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH)));
	
	if(m_pDC)
		pdc->BitBlt(0, 0, rcBounds.Width(), rcBounds.Height(), m_pDC, 0, 0, SRCCOPY);

	
	//	pdc->Ellipse(rcBounds);
		
}


/////////////////////////////////////////////////////////////////////////////
// CAtXControlCtrl::DoPropExchange - Persistence support

void CAtXControlCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

//	PX_String(pPX, "server", m_serverName);
//	PX_Long(pPX, "port", m_port);
	// TODO: Call PX_ functions for each persistent custom property.

}


/////////////////////////////////////////////////////////////////////////////
// CAtXControlCtrl::GetControlFlags -
// Flags to customize MFC's implementation of ActiveX controls.
//
// For information on using these flags, please see MFC technical note
// #nnn, "Optimizing an ActiveX Control".
DWORD CAtXControlCtrl::GetControlFlags()
{
	DWORD dwFlags = COleControl::GetControlFlags();


	// The control will not be redrawn when making the transition
	// between the active and inactivate state.
	dwFlags |= noFlickerActivate;
	return dwFlags;
}


/////////////////////////////////////////////////////////////////////////////
// CAtXControlCtrl::OnResetState - Reset control to default state

void CAtXControlCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}


/////////////////////////////////////////////////////////////////////////////
// CAtXControlCtrl::AboutBox - Display an "About" box to the user

void CAtXControlCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_ATXCONTROL); 
	dlgAbout.DoModal();
}


/////////////////////////////////////////////////////////////////////////////
// CAtXControlCtrl message handlers


void CAtXControlCtrl::Update(CSubject *pSubject)
{
	
	int * pint;
	int len = 0;
	if(pSubject == 0)
		return;
	ATSOCK_COMMAND * pC = (ATSOCK_COMMAND *) pSubject->GetData();

	if(pC == 0)
		return;

	switch(pC->command)
	{
	case ATSOCK_ONCONNECT:
		if(*(int *) pC->data != 0)
			FirePictureReady(ATERR_NOSERVER);
		
		m_busy = TRUE;
		if(m_Client.Send(m_sBuffer, 6 * sizeof(int)) == SOCKET_ERROR) // 6 parameters passed
		{
			FirePictureReady(ATERR_SENDERROR);
			Disconnect();
		}
		else
			FirePictureReady(ATNOTF_RQSEND);
		break;
	case ATSOCK_ONCLOSE:
		m_busy = FALSE;
		m_Client.Close();
		FirePictureReady(ATERR_DISCONNECT);
		break;
	case ATSOCK_ONSEND:
		if(*(int *) pC->data != 0)
			FirePictureReady(ATERR_SENDERROR);
		break;
	case ATSOCK_ONRECEIVE:
		if(*((int *)pC->data) == 0)
		{
			m_busy = TRUE;
			len = m_Client.Receive(m_rBuffer, sizeof(m_rBuffer));
			if(len > 0)
			{
				if(m_Size == 0)
				{
				//	m_Timer = SetTimer(1, 25000, NULL);
					pint = (int *) m_rBuffer;
					m_Size = *pint ++ - 7 * sizeof(int);
					m_picX = * pint ++;
					m_picY = * pint ++;
					m_picDX = * pint ++;
					m_picDY = * pint ++;
					m_picIX = * pint ++;
					m_picIY = * pint; 
					m_Cnt = len - 7 * sizeof(int);
					ASSERT(m_Cnt <= m_Size);
					if(m_pixar)
						delete[] m_pixar;
					m_pixar = new unsigned char[m_Size];
					if(m_pixar == NULL)
					{
						Disconnect();
						m_Size = 0;
						m_Cnt = 0;
						FirePictureReady(ATERR_NOMEM);
					}
					FirePictureReady(ATERR_PICRECV);
					memset(m_pixar, 0, m_Size);
					memcpy(m_pixar, m_rBuffer + 7 * sizeof(int), m_Cnt);
				}
				else
				{
					ASSERT(m_Cnt <= m_Size);
					if(m_Cnt < m_Size)
					{
						ASSERT(m_pixar + m_Cnt <= m_pixar + m_Size);
						memcpy(m_pixar + m_Cnt, m_rBuffer, len);
						m_Cnt += len;
					}
					if(m_Cnt == m_Size)
					{
					
						m_busy = FALSE;
						if(!m_bLive)
							Disconnect();
						CreatePicture(m_pixar, m_picX, m_picY, m_picDX, m_picDY, m_picIX, m_picIY);
						m_Size = 0;
						m_Cnt = 0;
						GdiFlush();
						Invalidate();
						FirePictureReady(ATERR_NOERROR);
						if(m_bLive)
						{
							m_busy = TRUE;
							if(m_Client.Send(m_sBuffer, 6 * sizeof(int)) == SOCKET_ERROR) // 6 parameters passed
							{
								FirePictureReady(ATERR_SENDERROR);
							//	Disconnect();
							}
							else
								FirePictureReady(ATNOTF_RQSEND);
						}
					
					}
					ASSERT(m_Cnt <= m_Size);
					
				}
			}
		}
		else
		{
			if(m_pDC)
			{
				if(m_pBmp)
					delete m_pBmp;
				m_pBmp = 0;
				delete m_pDC;
				m_pDC = 0;
			}

			Disconnect();
			m_Size = 0;
			m_Cnt = 0;
			if(m_pixar)
			{
				delete[] m_pixar;
				m_pixar = 0;
			}
			FirePictureReady(ATERR_RECVERROR);
		}
		break;
	default:
		break;
	}
}

BSTR CAtXControlCtrl::GetServer() 
{
	CString strResult;
	// TODO: Add your property handler here
	strResult = m_serverName;
	return strResult.AllocSysString();
}

void CAtXControlCtrl::SetServer(LPCTSTR lpszNewValue) 
{
	
	
	m_serverName = lpszNewValue;

	
	SetModifiedFlag();
}

long CAtXControlCtrl::GetPort() 
{
	// TODO: Add your property handler here
	long r = m_port;
	return r;
}

void CAtXControlCtrl::SetPort(long nNewValue) 
{
	// TODO: Add your property handler here
	m_port = nNewValue;
	SetModifiedFlag();
}

void CAtXControlCtrl::Disconnect()
{
	
	m_Client.Close();
	m_busy = FALSE;
}

void CAtXControlCtrl::RequestImage(long x, long y, long dx, long dy, long incrx, long incry) 
{
	BOOL val = TRUE;

	Disconnect();
	m_Client.Create();
	int * pint = (int *) m_sBuffer;
	*pint ++ = x;
	*pint ++ = y;
	*pint ++ = dx;
	*pint ++ = dy;
	*pint ++ = incrx;
	*pint = incry;
	
	m_Client.Connect(m_serverName, (UINT) m_port);

}


BOOL CAtXControlCtrl::GetBusy() 
{
	// TODO: Add your property handler here

	return m_busy;
}

void CAtXControlCtrl::SetBusy(BOOL bNewValue) 
{
	// TODO: Add your property handler here

//	SetModifiedFlag();
}

void CAtXControlCtrl::SetPosition(long x, long y, long dx, long dy) 
{
	// TODO: Add your dispatch handler code here
	::SetWindowPos(GetSafeHwnd(), NULL, x, y, dx, dy, SWP_NOZORDER);
}

void CAtXControlCtrl::Abort() 
{
	Disconnect();
	m_Cnt = 0;
	m_Size =0;

}

void CAtXControlCtrl::OnDestroy() 
{
	if(m_hBmp)
		DeleteObject(m_hBmp);

	if(m_pDC)
	{
		if(m_pBmp)
			delete m_pBmp;
		delete m_pDC;
	}
//	if(m_Timer)
//		KillTimer(m_Timer);
	COleControl::OnDestroy();
	
	// TODO: Add your message handler code here
	
}

BOOL CAtXControlCtrl::CreatePicture(unsigned char *image, int x0, int y0, int dx, int dy, int ix, int iy)
{
	UNUSED(x0);
	UNUSED(y0);

	

	
	BITMAPINFO * pBI = (BITMAPINFO *) m_bmpInfo;
	unsigned char *pxp, * ixp;
	int cx, cy, y, padd;
	BOOL r = FALSE;
	CDC * pDC;
	CDC dc;


	CBitmap * pB[2];

	ASSERT(image);
	if(dx <= 0 || dy <= 0 || ix <= 0 || iy <= 0)
	{
		FirePictureReady(ATERR_INVALIDPARAM);
		goto l_exit;
	}
	if(m_pDC)
	{
		if(m_pBmp)
			delete m_pBmp;
		m_pBmp = 0;

		delete m_pDC;
		m_pDC = 0;
	}

	
	pDC = GetDC();
	ASSERT(pDC);
	m_pDC = new CDC;
	m_pDC->CreateCompatibleDC(pDC);
	m_pBmp = new CBitmap;

	
	cx = (dx / ix) + (dx % ix > 0 ? 1 : 0);
	cy = (dy / iy) + (dy % iy > 0 ? 1 : 0);

	padd = ((cx + 3) / 4) * 4;

	m_pBmp->CreateCompatibleBitmap(pDC, cx, cy);



	pBI->bmiHeader.biHeight = - cy;
	pBI->bmiHeader.biWidth = padd;
	pBI->bmiHeader.biSizeImage = 0;
	pBI->bmiHeader.biClrImportant = 0;
	
	if(m_hBmp)
	{
		DeleteObject(m_hBmp);
		m_pixmap = 0;
	}

	m_hBmp = CreateDIBSection(m_pDC->GetSafeHdc(), pBI, DIB_RGB_COLORS, (void **) & m_pixmap, NULL, 0);

	ASSERT(m_hBmp);

	pB[0] = CBitmap::FromHandle(m_hBmp);

	ASSERT(pB[0]);

	pxp = m_pixmap;
	ixp = image;

	
	
	memset(m_pixmap, 0, padd * cy);

	for(y = 0; y < cy; y ++)
	{
		memcpy(pxp, ixp, cx);
		pxp += padd;
		ixp += cx;
	}

	dc.CreateCompatibleDC(pDC);
	pB[1] = (CBitmap *) dc.SelectObject(pB[0]);

	m_pDC->SelectObject(m_pBmp);

	m_pDC->BitBlt(0, 0, cx, cy, & dc, 0, 0, SRCCOPY);

	dc.SelectObject(pB[1]);


	ReleaseDC(pDC);
	r = TRUE;
l_exit:
	return r;
}


int CAtXControlCtrl::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (COleControl::OnCreate(lpCreateStruct) == -1)
		return -1;
//	DWORD d = GetClassLong(GetSafeHwnd(), GCL_STYLE);
//	d &= ~CS_PARENTDC;
//	SetClassLong(GetSafeHwnd(), GCL_STYLE, (LONG) d);
	// TODO:  Add your specialized creation code here

	//m_Client.Create();

	return 0;
}


/*
void CAtXControlCtrl::OnTimer(UINT nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	if(m_Timer == nIDEvent)
	{
		KillTimer(m_Timer);
		m_Timer = 0;
		Disconnect();
		m_Size = 0;
		m_Cnt = 0;
		if(m_pixar)
		{
			delete[] m_pixar;
			m_pixar = 0;
		}
		FirePictureReady(ATERR_RECVTOUT);
	}
	COleControl::OnTimer(nIDEvent);
}
*/

BOOL CAtXControlCtrl::GetLive() 
{
	// TODO: Add your property handler here

	return m_bLive;
}

void CAtXControlCtrl::SetLive(BOOL bNewValue) 
{
	// TODO: Add your property handler here

	m_bLive = bNewValue;
	SetModifiedFlag();
}

BOOL CAtXControlCtrl::SaveToBmp(LPCTSTR fileName) 
{
	
	BOOL r = FALSE;
	BITMAPFILEHEADER	hdr;
	BITMAPINFO * pBI = (BITMAPINFO *) m_bmpInfo;
	FILE * f;
	if(!m_hBmp || m_bLive)
		goto l_exit;
	f = fopen(fileName, "wb");
	if(f)
	{
		// Fill in the fields of the file header 
		hdr.bfType = ((WORD) ('M' << 8) | 'B');	// is always "BM"
		hdr.bfSize = sizeof(hdr) + sizeof(m_bmpInfo) - pBI->bmiHeader.biHeight * pBI->bmiHeader.biWidth; // height is negative!
		hdr.bfReserved1 = 0;
		hdr.bfReserved2 = 0;
		hdr.bfOffBits = sizeof(hdr) + sizeof(m_bmpInfo);

		// Write the file header 
		fwrite(&hdr, 1, sizeof(hdr), f);

		// Write color table and bitmap info
		fwrite(m_bmpInfo, 1, sizeof(m_bmpInfo), f);

		// Write pixel data
	
		fwrite(m_pixmap, 1, - pBI->bmiHeader.biHeight * pBI->bmiHeader.biWidth, f); // NEGATIVE!
		fclose(f);
		r = TRUE;
	}

	//DeleteObject(hbmp);
l_exit:
	return r;
}

void CAtXControlCtrl::GetImgAttrib(long FAR* x, long FAR* y, long FAR* dx, long FAR* dy) 
{
	// TODO: Add your dispatch handler code here
	*x = m_picX;
	*y = m_picY;
	*dx = (m_picDX / m_picIX) + (m_picDX % m_picIX > 0 ? 1 : 0);
	*dy = (m_picDY / m_picIY) + (m_picDY % m_picIY > 0 ? 1 : 0);
		
	
}


