// Subject.cpp: implementation of the CSubject class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Subject.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CSubject::CSubject()
{
	m_pData = NULL;
}

CSubject::~CSubject()
{

}

void CSubject::Notify()
{
	OBSERVER_PTR_LIST::iterator it;
	it = m_observers.begin();
	
	int size = m_observers.size();
	
	if(size > 0)
	{
		while(it != m_observers.end() && size > 0)
		{
			(*it)->Update(this);
			it ++;
			size = m_observers.size();
		}
	}
}

void CSubject::Attach(CObserver *pObserver)
{
	m_observers.push_back(pObserver);
}

void CSubject::Detach(CObserver *pObserver)
{
	if(m_observers.size() > 0)
		m_observers.remove(pObserver);
}

void * CSubject::GetData()
{
	return m_pData;
}

void CSubject::SetData(void *data)
{
	m_pData = data;
}
