// Subject.h: interface for the CSubject class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SUBJECT_H__F4994301_1771_4230_9848_0682188A7184__INCLUDED_)
#define AFX_SUBJECT_H__F4994301_1771_4230_9848_0682188A7184__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "Observer.h"
#include <list>

typedef std::list<CObserver *> OBSERVER_PTR_LIST;


class CSubject  
{
private:
	OBSERVER_PTR_LIST m_observers;
protected:
	void * m_pData;
	CSubject();
public:
	void SetData(void * data);
	void * GetData(void);
	void Detach(CObserver * pObserver);
	void Attach(CObserver * pObserver);
	virtual void Notify(void);
	
	virtual ~CSubject();

};

#endif // !defined(AFX_SUBJECT_H__F4994301_1771_4230_9848_0682188A7184__INCLUDED_)
