/************************************************************************************/
/*

Demo-Software for smart cameras from Vision Components
------------------------------------------------------

Program Description:
--------------------

Example of using trigger input and trigger output.
Please check the operating manual of your camera for
correct connection of trigin and trigout pin!


Revision History:
-----------------

   Date           Version    Author  Changes
   Jul 17, 2003   1.00       KS      Initial Version
   Apr 05, 2011   2.00       LB      Program now universal, macro TRIGINP_PIN valid on all cameras
   									 (from VCRT 5.30 only!!)

*/
/************************************************************************************/

#include <vcrt.h>
#include <vclib.h>
#include <macros.h>
#include <sysvar.h>

/************************************************************************************/

void main(void)

  {
  int TrigInp, Run = 1;
 
  TRIGINP_POS();     /* trigger on rising edge */
  
  tpict(); 	/* set allowed vmode for tenable() (still mode) */
  
  while(!kbhit())  
    {
	/* Display status of Trigger Input */
	TrigInp = TRIGINP_PIN;
	
    if (TrigInp)
      {
      print ("Trigger Input ON\n");
      }
    else
      {
      print ("Trigger Input OFF\n");
      }
      
    time_delay(20); // ms
    } 
 
  getchar();


  pstr("Waiting for Trigger (rising edge at Trig.Inp). Press any key to quit\n");

 
  TRIGOUT_EXP();      /* set trigger output to exposure controlled mode */
  TRIGOUT_NEG();      /* low level = exposure                           */

  while(Run)  
    {

    tenable();        /* now wait for external trigger    */
  

	    while(!trdy())    /* wait for completion*/     
	    {
		      if (kbhit())
		      {
		        print("kill capture\n");
		        getchar();
		      	while(cancel_capture_rq());
		      	Run = 0;
		      }      
	    }

  	pstr("*");
    }
 vmode(vmLive);

 }

/************************************************************************************/
