/************************************************************************************/
/*

Demo-Software for smart cameras from Vision Components
------------------------------------------------------

Program Description:
--------------------

Example of using trigger output.

Please check the operating manual of your camera for
correct connection of trigout pin, a pull-up resistance
may be necessary!

IMPORTANT : user defined trigger output DOES NOT WORK on VC nano cameras!!


Revision History:
-----------------

   Date           Version    Author  Changes
   Jul 17, 2003   1.00       KS      Initial Version
   Apr 05, 2011   2.00       LB      Updated comments

*/
/************************************************************************************/

#include <vcrt.h>
#include <vclib.h>
#include <macros.h>
#include <sysvar.h>

/*******************************************************************/

void main(void)

  {
  print("User defined TRIGGER OUTPUT\n\n");

  TRIGOUT_USR();       /* set trigger output to user mode      */
  TRIGOUT_POS();       /* normal output, not inverse            */

  SET_TRIGOUT();
  pstr("set trig out = high voltage\n");
  print("Press any key\n"); rs232rcv();

  RES_TRIGOUT();
  pstr("reset trig out = low voltage\n");
  print("Press any key\n"); rs232rcv();



  print("\n\nExposure time defined TRIGGER OUTPUT\n\n");

  TRIGOUT_EXP();      /* set trigger output to exposure controlled mode */
  TRIGOUT_NEG();      /* low level = exposure                           */

  print("Trigger Output is on during the exposure time (shutter time)\n"); rs232rcv();
  print("Press any key to take a picture\n"); rs232rcv();
  tpict();
  }

/*******************************************************************/
