/*******************************************************************/
/*

Demo-Software for smart cameras from Vision Components
------------------------------------------------------

Program: Peter Neuhaus,  VC

Program Description:
--------------------


*/
/*******************************************************************/

#include <vcrt.h>
#include <vclib.h>
#include <macros.h>
#include <sysvar.h>
#include <flib.h> 

/*******************************************************************/

void main(void)
{
 
  int Screen1, Screen2_not_aligned,  Screen2;
  int ms, key = 0;
  image CleanScreen, a, b;  
   
    /*******************************************************************************/
    /*                 PLEASE INITIALIZE YOUR LICENCE CODES                        */
    /*                    To activate library functions                            */
    /*                                                                             */
    /* VCLIB :         init_licence("T1122334455") or init_licence("LT1122334455") */
    /* Extension Lib : init_licence("E1122334455") or init_licence("LE1122334455") */
    /* Color Lib :     init_licence("C1122334455") or init_licence("LC1122334455") */
    /* etc.                                                                        */
    /*                                                                             */
    /*      init_licence() returns 0 if licence code is OK, -5 otherwise           */
    /*                                                                             */
    /* Example :                                                                   */
    /*                                                                             */
	/**/ 	print("Init VCLIB = %d\n", init_licence("T1122334455"));			 /**/
    /*******************************************************************************/
  
  /* Memory Allocation for addtional image pages */
      // obtaining start address of page 1 = default capture page
      Screen1 = ScrGetCaptPage;

      // Allocate screen page 2
      Screen2_not_aligned = (int)DRAMDisplayMalloc();
      Screen2 = (Screen2_not_aligned&0xFFFFFC00) + 1024;

  /*  Clean borders */
      ImageAssign(&CleanScreen, Screen1, DispGetColumns, DispGetRows, DispGetPitch);
      set(&CleanScreen, 0);
      ImageAssign(&CleanScreen, Screen2, DispGetColumns, DispGetRows, DispGetPitch);
      set(&CleanScreen, 0);
     

  /* Assiging image variables for source and destination for Sobel filter */
      ImageAssign(&a, Screen1, DispGetColumns, DispGetRows, DispGetPitch);
      ImageAssign(&b, Screen2, DispGetColumns, DispGetRows, DispGetPitch);
  
  
     
      vmode(0); //turing the camera into live mode

     do
      {
      
      if (kbhit()) key = rs232rcv();

	  ms = getvar(MSEC);

      ScrSetLogPage(Screen2);
	  sobel(&b,&b);
      ScrSetDispPage(Screen2);
      display_update(2); //Update Display and Overlay von video output
      ScrSetCaptPage(Screen1);
	  tpict(); //takes 1 image and turns camera into still mode
     
      ScrSetLogPage(Screen1);
	  sobel(&a,&a);
	  ScrSetDispPage(Screen1);
      display_update(2); //Update Display and Overlay von video output
	  ScrSetCaptPage(Screen2);
	  tpict();  //takes 1 image and turns camera into still mode

      ms = getvar(MSEC)-ms;
      if(ms<0) ms+=1000;
      print("Sobel:     t=%dms\n",ms);

	  }
	  while(key != 'q');

      ScrSetDispPage(Screen1);
      ScrSetCaptPage(Screen1);
      ScrSetLogPage(Screen1);

      vmode(0); //switching camera back to live mode

      // Release allocation
                                        // release memory in 
      DRAMPgFree(Screen2_not_aligned); // reverse order!!     
}

/*******************************************************************/

