/*******************************************************************/
/*

Demo-Software for smart cameras from Vision Components
------------------------------------------------------

Program: Peter Neuhaus,  VC


Program Description:
--------------------


*/
/*******************************************************************/

#include <vcrt.h>
#include <vclib.h>
#include <macros.h>
#include <sysvar.h>
#include <flib.h>

/*******************************************************************/

void main(void)
{
  int ms=0, ms1, ms2, ms3, ms4, ms5, tc_rq, texp, ttr, ttot, x =3, y=3;
  int TrackNr[3];
  int key = 0, ImgNr ;
  
    /*******************************************************************************/
    /*                 PLEASE INITIALIZE YOUR LICENCE CODES                        */
    /*                    To activate library functions                            */
    /*                                                                             */
    /* VCLIB :         init_licence("T1122334455") or init_licence("LT1122334455") */
    /* Extension Lib : init_licence("E1122334455") or init_licence("LE1122334455") */
    /* Color Lib :     init_licence("C1122334455") or init_licence("LC1122334455") */
    /* etc.                                                                        */
    /*                                                                             */
    /*      init_licence() returns 0 if licence code is OK, -5 otherwise           */
    /*                                                                             */
    /* Example :                                                                   */
    /*                                                                             */
	/**/ 	print("Init VCLIB = %d\n", init_licence("T1122334455"));			 /**/
    /*******************************************************************************/

  tpict();


  ////////////////////////////////////
  // 1. image aquisition with tpict //
  ////////////////////////////////////


  ms = getvar(MSEC);

  tpict();  
   
  ms = getvar(MSEC)-ms;

  if(ms<0) ms+=1000;

  print("tpict = shutter speed + transfer time t=%dms\n",ms);

  print("\nPress any key - \n "); getchar();


  //////////////////////////////////////////////////////////////////////
  // 2. image aquisition with capture_request polling tracking number //
  //////////////////////////////////////////////////////////////////////
   
 
  ms1 = getvar(MSEC);

  TrackNr[0] = capture_request(getvar(EXPCNT), getvar(GAIN),(int*)ScrGetCaptPage,0);

  ms2 = getvar(MSEC);

  while(TrackNr[0]== getvar(EXPOSING));

   
  ms3 = getvar(MSEC);

  while(TrackNr[0] == getvar(STORING));


  ms4 = getvar(MSEC);

  while(TrackNr[0] != getvar(IMGREADY));
 
  ms5 = getvar(MSEC);

  
	  tc_rq = ms2 - ms1;
	  if (tc_rq<0) tc_rq+=1000;
	  
	  texp = ms3 - ms2;
	  if (texp<0) texp+=1000;

	  ttr = ms4 -ms3;
	  if (ttr<0) ttr+=1000;
	  
	  ttot = ms5- ms1;
	  if (ttot<0) ttot+=1000;

  print("tc_rq = %d, texp = %d,  ttr = %d, ttot = %d \n", tc_rq, texp, ttr, ttot);




  ///////////////////////////////////////////////////////////
  // 3. image aquisition with capture_request using events //
  ///////////////////////////////////////////////////////////


  print("\nPress any key - \n"); getchar();

  wait(EXP_READY, 1); // in case the event has already occured and wait returns 2

  ms1 = getvar(MSEC);

  TrackNr[1] = capture_request(getvar(EXPCNT), getvar(GAIN),(int*)ScrGetCaptPage,0);
  ms2 = getvar(MSEC);
 
  
  do 
    {
    x = wait(EXP_READY,100); // waits until next event "Exposure Ready" occurs, timeout 100 ms
    } while(x!=1); // wait returns 2 and does not wait for the next event, if the event has occured before wait was called
 
 
  ms3 = getvar(MSEC);
 
   
  do
    {
	y = wait(IMAGE_READY, 100); // waits until next event "Image Ready" occurs, timeout 100 ms 
    } while(y!=1); // wait returns 2 and does not wait for the next event, if the event has occured before wait was called

  

  ms4 = getvar(MSEC);

	  
	  tc_rq = ms2 - ms1;
	  if (tc_rq<0) tc_rq+=1000;
	  
	  texp = ms3 - ms2;
	  if (texp<0) texp+=1000;

	  ttr = ms4 -ms3;
	  if (ttr<0) ttr+=1000;
	  
	  ttot = ms4- ms1;
	  if (ttot<0) ttot+=1000;


  print("tc_rq = %d, texp = %d,  ttr = %d, ttot = %d \n\n", tc_rq, texp, ttr, ttot);

  print("tracking No 1 = %d , tracking No.2 = %d \n", TrackNr[0], TrackNr[1]);

  print("x= %d, y= %d \n", x, y);



 switch(x)
       {
	   case 1:
        	print("exposure ready event occured\n");
            break;
       case 2:  
            print("exposure ready event has occured before wait was called occured\n");
            break;
       case -1:  
            print("exposure ready event has timed out\n");
            break;
       default:
	        print("Return value wait(EXP_READY,x) = %d \n", x);
       }

switch(y)
       {
	   case 1:
        	print("image ready event occured\n");
            break;
       case 2:  
            print("image ready event has occured before wait was called\n");
            break;
       case -1:  
            print("image ready event has timed out\n");
            break;       
       default:
	        print("Return value wait(IMAGE_READY,x) = %d \n", y);
       }



 ///////////////////////////////////////////////////////////
 // 4. image aquisition loop using getvar(IMGREADY)       //
 ///////////////////////////////////////////////////////////


  print("\nPress any key to start image loop polling \n Press 'q' to stop \n"); getchar();


      do
        {
         if (kbhit())
		     {
			 key = rs232rcv();
			 }
            

           ImgNr = capture_request(getvar(EXPCNT), getvar(GAIN),(int*)ScrGetCaptPage,0);


            while(ImgNr != getvar(IMGREADY));    
        

        }
	 while(key != 'q');

     key = 'a';

//////////////////////////////////////////////////////////////////////
 // 5. image aquisition loop using events  wait(IMAGE_READY, 200)); //
 /////////////////////////////////////////////////////////////////////


  print("\nPress any key to start image loop using events \n Press 'q' to stop \n"); getchar();


      do
        {
         if (kbhit())
		     {
			 key = rs232rcv();
			 }
            

            capture_request(getvar(EXPCNT), getvar(GAIN),(int*)ScrGetCaptPage,0);
        
            while(wait(IMAGE_READY,100)!= 1);  
        

        }
	 while(key != 'q');




   vmode(vmLive);

}

/*******************************************************************/

