/************************************************************************************************************************/
/*    

Programmer:  Klaus Schneider, Vision Components GmbH
Date:        14.08.2005


*/
/************************************************************************************************************************/

#include <vcrt.h>
#include <vclib.h>
#include <macros.h>
#include <sysvar.h>
#include <flib.h>

/************************************************************************************************************************/

/*****************************/
/* VC SBC4018                */
/*****************************/

#define SBC4018

#ifdef SBC4018

  #define  vmode(vmOvlLive)         vmode(vmLive)
  #define  vmode(vmOvlStill)        vmode(vmStill)
  #define  vmode(vmOvlLiveRefresh)  vmode(vmLive)
  #define  vmode(vmOvlFreeze)       vmode(vmStill)

  #define  set_ovlmask(x)  


#define vmLive                  (0)
#define vmStill                 (1)
#define vmLiveRefresh           (2)
#define vmFreeze                (3)
#define vmOvlLive               (4)
#define vmOvlStill              (5)
#define vmOvlLiveRefresh        (6)
#define vmOvlFreeze             (7)

#endif

/*
Differences SBC4018 -> VC20xx and VC40xx:
-----------------------------------------

- no overlay page 
- no video output

*/

/***************************************************************************************************************************/

void SBC4018_END         (void);
void SBC4018_INI         (void);

/************************************************************************************************************************/
/************************************************************************************************************************/
/************************************************************************************************************************/

void main (void)

  {

  // initialize Data Matrix Reader for SBC4018
  #ifdef SBC4018
    SBC4018_INI();
  #endif




  // my program code




  // initialize Data Matrix Reader for SBC4018
  #ifdef SBC4018
    SBC4018_END();
  #endif
  }

/************************************************************************************************************************/

void SBC4018_INI (void)
{
  // important for macros like DRAMDisplMalloc()
  setvar(DVWIDTH, getvar(VWIDTH));          
  setvar(DHWIDTH, getvar(HWIDTH));

  // ini display start addr with CAPT_START
  setvar(DISP_START, getvar(CAPT_START));

  // allocate overlay page for using overlay functions as usual
  setvar(OVLY_START, DRAMScreenMalloc());

  // set working page to physical page
  ScrSetLogPage((int)ScrGetPhysPage);
  OvlSetLogPage((int)OvlGetPhysPage);
}

/************************************************************************************************************************/

void SBC4018_END (void)
{
  /* release screen allocation */
  DRAMPgFree(getvar(OVLY_START));
}

/************************************************************************************************************************/
