#include <vcrt.h>
#include <vclib.h>
#include <sysvar.h>

/* info.msf informs the user about the current settings of some system vars*/

void main()
{
/*
  long st_ovl = (long)pgsize*getvar(ovpage) - (long)Offset_Overlay/8;
  int offset_overlay = Offset_Overlay;
*/

  print("**********************\n"); 
  print("* System-Variables   *\n");
  print("**********************\n\n");
  print("model                : VC%d\n",getvar(MODEL));
  print("cpu clock frequency  : %ld \n",(long)getvar(CPUCLK));
/*
  print("current video line   : %d \n",getvar(vline));
*/
  print("SDRAM size           : 0x%08lx\n",(long)getvar(DRAMSIZE));
  print("startaddress display : 0x%08lx\n",(long)getvar(DISP_START));
  print("startaddress overlay : 0x%08lx\n",(long)getvar(OVLY_START));
  print("startaddress capture : 0x%08lx\n",(long)getvar(CAPT_START));
  print("active hor. pixels   : %d \n",getvar(HWIDTH));
  print("active ver. pixels   : %d \n",getvar(VWIDTH));
  print("pitch                : %d \n",getvar(VPITCH));
  print("display hor. pixels  : %d \n",getvar(DHWIDTH));
  print("display ver. pixels  : %d \n",getvar(DVWIDTH));
  print("stack pointer        : 0x%08lx\n",(long)getstptr());
  print("data pointer         : 0x%08lx\n",(long)getdp());
  print("bss                  : 0x%08lx\n",(long)getbss());
  print("exp unit in micros   : %d \n",getvar(EXUNIT));
  print("exposure timestamps  : 0x%08lx\n",getvar(TIMESTAMP));
  {
   	int i;
	imgts * ts_table = (imgts *)getvar(TIMESTAMP);
    for(i=1;i<=IMGTS_SIZE && ts_table;i++,ts_table++)
   	{
        print("%02d (0x%x) ",i,ts_table);
        print("nr= %d ",ts_table->imageno);
        print("ts= %lu\n",ts_table->exptimestamp);
	}
  }
  print("uptime               : %d \n",getvar(UPTIME));
  print("sysmem structure at  : 0x%08lx\n",(long)getvar(SYSMEM));
  print("testversion          : %d \n",getvar(TESTVERSION));
  print("private sysvars index: %d \n",getvar(PRIVATE));
  print("ethernet link        : %d \n",getvar(ETHLINK));
  print("interrupt latency    : %d\n",getvar(LATENCY));
  print("interrupt ltest      : %d\n",getvar(LTEST));
  print("EMAC counter         : %d\n",getvar(EMAC_COUNT));
  print("Gain                 : 0x%x \n",getvar(GAIN));
  print("EXPCNT               : %d \n",getvar(EXPCNT));

}

