/*******************************************************************/
/*

Demo-Software for smart cameras from Vision Components
------------------------------------------------------

Program: Loic Burner,  VC


Program Description:
--------------------

This program shows a comparison of some time related functions.

*/
/*******************************************************************/

#include <vcrt.h>
#include <vclib.h>
#include <macros.h>
#include <sysvar.h>

/*******************************************************************/

void main(void)
{
	int csec, cmin, chour, lsec, lmin, lhour, gsec, gmin, ghour;
	int zsec = getlvar(SEC);

	/* Timezone 0, Daylight 0 */
	setvar(TIMEZONE, 0);
	setvar(DAYLIGHT, 0);

	print("TIMEZONE=%d, DAYLIGHT=%d\n", getvar(TIMEZONE), getvar(DAYLIGHT));

	c_time(zsec, getvar(TIMEZONE), &csec, &cmin, &chour);
	print("c_time, system time + timezone=%d :  %d:%d:%d\n", getvar(TIMEZONE), chour, cmin, csec);

	ltime(&lsec, &lmin, &lhour);
	print("ltime, local time (timezone=%d + daylight=%d) :  %d:%d:%d\n", getvar(TIMEZONE), getvar(DAYLIGHT), lhour, lmin, lsec);

	gtime(&gsec, &gmin, &ghour);
	print("gtime, GMT time : %d:%d:%d\n\n", ghour, gmin, gsec);


	/* Timezone 1, Daylight 0 */
	setvar(TIMEZONE, 1);
	setvar(DAYLIGHT, 0);

	print("TIMEZONE=%d, DAYLIGHT=%d\n", getvar(TIMEZONE), getvar(DAYLIGHT));

	c_time(zsec, getvar(TIMEZONE), &csec, &cmin, &chour);
	print("c_time, system time + timezone=%d :  %d:%d:%d\n", getvar(TIMEZONE), chour, cmin, csec);

	ltime(&lsec, &lmin, &lhour);
	print("ltime, local time (timezone=%d + daylight=%d) :  %d:%d:%d\n", getvar(TIMEZONE), getvar(DAYLIGHT), lhour, lmin, lsec);

	gtime(&gsec, &gmin, &ghour);
	print("gtime, GMT time : %d:%d:%d\n\n", ghour, gmin, gsec);


	/* Timezone 0, Daylight 1 */
	setvar(TIMEZONE, 0);
	setvar(DAYLIGHT, 1);

	print("TIMEZONE=%d, DAYLIGHT=%d\n", getvar(TIMEZONE), getvar(DAYLIGHT));

	c_time(zsec, getvar(TIMEZONE), &csec, &cmin, &chour);
	print("c_time, system time + timezone=%d :  %d:%d:%d\n", getvar(TIMEZONE), chour, cmin, csec);

	ltime(&lsec, &lmin, &lhour);
	print("ltime, local time (timezone=%d + daylight=%d) :  %d:%d:%d\n", getvar(TIMEZONE), getvar(DAYLIGHT), lhour, lmin, lsec);

	gtime(&gsec, &gmin, &ghour);
	print("gtime, GMT time : %d:%d:%d\n\n", ghour, gmin, gsec);


	/* Timezone 1, Daylight 1 */
	setvar(TIMEZONE, 1);
	setvar(DAYLIGHT, 1);

	print("TIMEZONE=%d, DAYLIGHT=%d\n", getvar(TIMEZONE), getvar(DAYLIGHT));

	c_time(zsec, getvar(TIMEZONE), &csec, &cmin, &chour);
	print("c_time, system time + timezone=%d :  %d:%d:%d\n", getvar(TIMEZONE), chour, cmin, csec);

	ltime(&lsec, &lmin, &lhour);
	print("ltime, local time (timezone=%d + daylight=%d) :  %d:%d:%d\n", getvar(TIMEZONE), getvar(DAYLIGHT), lhour, lmin, lsec);

	gtime(&gsec, &gmin, &ghour);
	print("gtime, GMT time : %d:%d:%d\n\n", ghour, gmin, gsec);

}
