#include <register.h>
#include <vcrt.h>
#include <sysvar.h>



/* PLL frequency calculation for Micron MT9P031 sensor												*/
/*																									*/
/* (1) PIXCLK = (EXTCLK * M) / (N * P1)																*/
/* (2) P1 must be even																				*/
/* (3) 2 MHz < EXTCLK/N	< 13.5 MHz																	*/
/* (4) 180 MHz < (EXTCLK * M)/N < 360 MHz															*/
/* (5) 16 <= M <= 255																				*/
/*																									*/
/* calculated settings:																				*/
/*																									*/
/* EXTCLK = 25 MHz																					*/
/* M  = 64				(3) EXTCLK/N       =   5 MHz	condition met								*/
/* N  = 5				(4) (EXTCLK * M)/N = 320 MHz	condition met								*/
/* P1 = 4				(5) 16 <= 64 <= 255				condition met								*/

#define PLL_m			(64)	/* M 		from formula (1)			*/
#define PLL_n			(4)		/* N  - 1	with N from formula (1)		*/
#define PLL_p1			(3)		/* P1 - 1	with P1 from formula (1)	*/
#define SEN_ADR         (0x5D)



main()
{
int i;
char i2c_sendbuf[] = {0x10 , 0, 0x51, PLL_m, PLL_n, 0, PLL_p1, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };

printf("i2c test routines for SBC4012\n");

shutter(100000); /* this seems to be necessary for the setting of the GRR bit	*/
tpict(); // stop running live mode


// snapshot mode and trigger invert
i2c_sendbuf[0] = 0x1e;
i2c_sendbuf[1] = 0x43;
i2c_sendbuf[2] = 0x16|(1<<7); // TEST global reset
i2c_edma_write(3, SEN_ADR, i2c_sendbuf);
time_delay(100);



shutter(10000); 	// Reset shutter to original value, 10 ms


}





/* EOF */
