#define DM6435
#include <register.h>
#include <vcrt.h>
#include <vclib.h>
#include <flib.h>
#include <macros.h>
#include <sysvar.h>

#if 0
#include "evmdm6437.h"
#else
#define Uint32  unsigned int

/* ------------------------------------------------------------------------ *
 *                                                                          *
 *   VPFE CCD Controller                                                    *
 *                                                                          *
* ------------------------------------------------------------------------ */
#define VPFE_CCDC_BASE          0x01C70400
#define VPFE_CCDC_PID           *( volatile Uint32* )( VPFE_CCDC_BASE + 0x00 )
#define VPFE_CCDC_PCR           *( volatile Uint32* )( VPFE_CCDC_BASE + 0x04 )
#define VPFE_CCDC_SYN_MODE      *( volatile Uint32* )( VPFE_CCDC_BASE + 0x08 )
#define VPFE_CCDC_HD_VD_WID     *( volatile Uint32* )( VPFE_CCDC_BASE + 0x0c )
#define VPFE_CCDC_PIX_LINES     *( volatile Uint32* )( VPFE_CCDC_BASE + 0x10 )
#define VPFE_CCDC_HORZ_INFO     *( volatile Uint32* )( VPFE_CCDC_BASE + 0x14 )
#define VPFE_CCDC_VERT_START    *( volatile Uint32* )( VPFE_CCDC_BASE + 0x18 )
#define VPFE_CCDC_VERT_LINES    *( volatile Uint32* )( VPFE_CCDC_BASE + 0x1C )
#define VPFE_CCDC_CULLING       *( volatile Uint32* )( VPFE_CCDC_BASE + 0x20 )
#define VPFE_CCDC_HSIZE_OFF     *( volatile Uint32* )( VPFE_CCDC_BASE + 0x24 )
#define VPFE_CCDC_SDOFST        *( volatile Uint32* )( VPFE_CCDC_BASE + 0x28 )
#define VPFE_CCDC_SDR_ADDR      *( volatile Uint32* )( VPFE_CCDC_BASE + 0x2c )
#define VPFE_CCDC_CLAMP         *( volatile Uint32* )( VPFE_CCDC_BASE + 0x30 )
#define VPFE_CCDC_DCSUB         *( volatile Uint32* )( VPFE_CCDC_BASE + 0x34 )
#define VPFE_CCDC_COLPTN        *( volatile Uint32* )( VPFE_CCDC_BASE + 0x38 )
#define VPFE_CCDC_BLKCMP        *( volatile Uint32* )( VPFE_CCDC_BASE + 0x3c )
#define VPFE_CCDC_FPC_ADDR      *( volatile Uint32* )( VPFE_CCDC_BASE + 0x40 )
#define VPFE_CCDC_FPC           *( volatile Uint32* )( VPFE_CCDC_BASE + 0x44 )
#define VPFE_CCDC_VDINT         *( volatile Uint32* )( VPFE_CCDC_BASE + 0x48 )
#define VPFE_CCDC_ALAW          *( volatile Uint32* )( VPFE_CCDC_BASE + 0x4c )
#define VPFE_CCDC_REC656IF      *( volatile Uint32* )( VPFE_CCDC_BASE + 0x50 )
#define VPFE_CCDC_CCDCFG        *( volatile Uint32* )( VPFE_CCDC_BASE + 0x54 )
#define VPFE_CCDC_FMTCFG        *( volatile Uint32* )( VPFE_CCDC_BASE + 0x58 )
#define VPFE_CCDC_FMT_HORZ      *( volatile Uint32* )( VPFE_CCDC_BASE + 0x5c )
#define VPFE_CCDC_FMT_VERT      *( volatile Uint32* )( VPFE_CCDC_BASE + 0x60 )
#define VPFE_CCDC_FMT_ADDR0     *( volatile Uint32* )( VPFE_CCDC_BASE + 0x64 )
#define VPFE_CCDC_FMT_ADDR1     *( volatile Uint32* )( VPFE_CCDC_BASE + 0x68 )
#define VPFE_CCDC_FMT_ADDR2     *( volatile Uint32* )( VPFE_CCDC_BASE + 0x6c )
#define VPFE_CCDC_FMT_ADDR3     *( volatile Uint32* )( VPFE_CCDC_BASE + 0x70 )
#define VPFE_CCDC_FMT_ADDR4     *( volatile Uint32* )( VPFE_CCDC_BASE + 0x74 )
#define VPFE_CCDC_FMT_ADDR5     *( volatile Uint32* )( VPFE_CCDC_BASE + 0x78 )
#define VPFE_CCDC_FMT_ADDR6     *( volatile Uint32* )( VPFE_CCDC_BASE + 0x7c )
#define VPFE_CCDC_FMT_ADDR7     *( volatile Uint32* )( VPFE_CCDC_BASE + 0x80 )
#define VPFE_CCDC_PRGEVEN_0     *( volatile Uint32* )( VPFE_CCDC_BASE + 0x84 )
#define VPFE_CCDC_PRGEVEN_1     *( volatile Uint32* )( VPFE_CCDC_BASE + 0x88 )
#define VPFE_CCDC_PRGODD_0      *( volatile Uint32* )( VPFE_CCDC_BASE + 0x8c )
#define VPFE_CCDC_PRGODD_1      *( volatile Uint32* )( VPFE_CCDC_BASE + 0x90 )
#define VPFE_CCDC_VP_OUT        *( volatile Uint32* )( VPFE_CCDC_BASE + 0x94 )
#endif

void set_res(int width, int height);
int set_image_format(int hpos, int vpos, int hsize, int vsize);

#define SEN_ADR (0x5C)

#define VER "1.4"

//
// set resolution on vc6210 sensor demo
//
// Author: Michael Steinel Date: 11.08.2010
// 
int no_sysvar_change=1;
int debug = 1;
int hb=0;
int vb=45;// 2 is minimum - 45 is standard
int x = 128;
int y = 128;

int main(int argc, char * argv)
{
//if(argc) debug = 0;

if(argc) no_sysvar_change = atoi(argv);

if(no_sysvar_change==2)
{
setvar(HWIDTH, 752);
setvar(VWIDTH, 480);
setvar(VPITCH, 768);
printf("RESET sysvars HWIDTH, VWIDTH and VPITCH !!!\n");
}

printf("resolution test routines for VC6210 Version %s\n",VER);
printf("compiled at %s %s\n", __DATE__, __TIME__);
printf("=== use 'mf3 0' option to change sysvars to new resolution    ===\n");
printf("=== use 'mf3 1' option to leave sysvars as they are (default) ===\n");
printf("=== use 'mf3 2' option to reset sysvars to initial values     ===\n");

tpict(); // stop running live mode

//exec2("fd://img2b.exe"); // start monitor

#if 0
//while(1)
{
  int i;
  for(i=0;i<128;i++)
  {
	 set_image_format(i,i,640,240); // move window
	 tpict();
  }
  for(i=128;i;i--)
  {
	 set_image_format(i,i,640,240); // move window
	 tpict();
  }
}
#else
//set_image_format(0,0,752,480); // centered vga window
//set_image_format(0,0,565,100); // centered vga window
set_image_format((752-x)/2,(480-y)/2,x,y); // automatic centered window
#endif
tpict();

printf("Wait 1s for capture queue empty\n");
time_delay(1000); // wait for capture queue empty

vmode(vmLive); // restart live mode

return 0;
}

int set_image_format(int hpos, int vpos, int hsize, int vsize)
{
char i2c_sendbuf[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
int hs=hsize;

if(hsize < 627)
{
    print("set_image_format(): hsize values lower as 627 will add extra horizontal blanking!\n");
}

if(no_sysvar_change==0)
{
setvar(HWIDTH, hsize);
setvar(VWIDTH, vsize);
}

if(hsize % 64)
{
hsize=(hsize/64)*64+64;
print ("Warning pitch adjusted to multiple of 64!\n");
}

if(no_sysvar_change==0)
{
    setvar(VPITCH, hsize);
    printf("changed sysvars HWIDTH, VWIDTH and VPITCH !!!\n");
}

if(debug)
print("size (h, v, vp):  [%d, %d, %d]\n", hs, vsize, getvar(VPITCH));

if(hpos<1)
  hpos = 1; // minimal value x
if(vpos<4)
  vpos = 4; // minimal value y

if(debug)
print("pos (hpos, vpos):  [%d, %d]\n", hpos, vpos);

if(hsize > 627)
  hb = 94; // 94 = standard , 61 = tuned
else
  hb = 94 + 627 - hsize; // tune + adjusted

if(debug)
print("blanking (hb, vb):  [%d, %d]\n", hb, vb);

//R01 Colum Start (1-752) def=1
i2c_sendbuf[0] = 0x01;
i2c_sendbuf[1] = hpos >> 8;
i2c_sendbuf[2] = hpos & 0xff;
i2c_edma_write(3, SEN_ADR, i2c_sendbuf);
time_delay(2);

//R02 Row Start (4-482) def=4
i2c_sendbuf[0] = 0x02;
i2c_sendbuf[1] = vpos >> 8;
i2c_sendbuf[2] = vpos & 0xff;
i2c_edma_write(3, SEN_ADR, i2c_sendbuf);
time_delay(2);

//R03 Window Height (1-480) def=480
i2c_sendbuf[0] = 0x03;
i2c_sendbuf[1] = vsize >> 8;
i2c_sendbuf[2] = vsize & 0xff;
i2c_edma_write(3, SEN_ADR, i2c_sendbuf);
time_delay(2);

//R04 Window Width (1-752) def=752
i2c_sendbuf[0] = 0x04;
i2c_sendbuf[1] = hs >> 8;
i2c_sendbuf[2] = hs & 0xff;
i2c_edma_write(3, SEN_ADR, i2c_sendbuf);
time_delay(2);

//R05  Horizontal Blanking (61-1023) def=94
//     minimum is -> normal: 61, binning*2: 71, binning*4: 91
i2c_sendbuf[0] = 0x05;
i2c_sendbuf[1] = hb >> 8;
i2c_sendbuf[2] = hb & 0xff;
i2c_edma_write(3, SEN_ADR, i2c_sendbuf);
time_delay(2);

//R06  Vertical Blanking (2-32288) def=45
i2c_sendbuf[0] = 0x06;
i2c_sendbuf[1] = vb >> 8;
i2c_sendbuf[2] = vb & 0xff;
i2c_edma_write(3, SEN_ADR, i2c_sendbuf);
time_delay(2);

#if 0 // TEST BINNING 2*2
//R0xD h+v binning 2 * 2  (0x0300)
i2c_sendbuf[0] = 0x0D;
i2c_sendbuf[1] = 0x03;
i2c_sendbuf[2] = 0x05;
time_delay(2);
i2c_edma_write(3, SEN_ADR, i2c_sendbuf);
time_delay(2);
#endif

// disable noise correction because it does not work with color version ! 
i2c_sendbuf[0] = 0x70;
i2c_sendbuf[1] = 0x00;
i2c_sendbuf[2] = 0x00;

i2c_edma_write(3, SEN_ADR, i2c_sendbuf);
time_delay(2);

#if 0
// TEST invert pixel clock 
i2c_sendbuf[0] = 0x72;
i2c_sendbuf[1] = 0x00;
i2c_sendbuf[2] = 0x10;

i2c_edma_write(3, SEN_ADR, i2c_sendbuf);
time_delay(2);
#endif

set_res(hsize,vsize); //reprogram DMA
return 0;
}


//MS 10.08.2010 set resolution of camera VC6210
void set_res(int width, int height)
{
  /* capturing video in raw data mode                                                             */
  VPFE_CCDC_PCR       = 0x00000000;   // Disable CCDC
 
//  CFG_VPSS_CLKCTL     = 0x00000003;   // MUXSEL = PCLK
  if( (getvar(VERSION) == 529 && getvar(TESTVERSION) >= 13) || getvar(VERSION) > 529 )
  {
  VPFE_CCDC_SYN_MODE  = 0x00030f00;   // WEN=1 VHDEN=1 PACK8=1 DATSIZ=7 EXWEN=0 H/V=NEGATIVE
  VPFE_CCDC_HORZ_INFO = ((0)<<16)+(width-1);// Horizontal lines
  }
  else
  {
  VPFE_CCDC_SYN_MODE  = 0x00030f0C;   // WEN=1 VHDEN=1 PACK8=1 DATSIZ=7 EXWEN=0 H/V=NEGATIVE
  VPFE_CCDC_HORZ_INFO = ((hb)<<16)+(width-1);// Horizontal lines
  }
  VPFE_CCDC_HD_VD_WID = 0;            // unused because HD, VD are inputs
  VPFE_CCDC_PIX_LINES = 0;            // unused because HD, VD are inputs
  VPFE_CCDC_HSIZE_OFF = getvar(VPITCH);// Horizontal line offset in SDRAM
  VPFE_CCDC_VERT_START= 0;            // Vertical start line
  VPFE_CCDC_VERT_LINES= height-1;     // Vertical lines
  VPFE_CCDC_SDOFST    = 0;
  VPFE_CCDC_SDR_ADDR  = (uint_32)(getvar(CAPT_START));
  VPFE_CCDC_CLAMP     = 0;
  VPFE_CCDC_DCSUB     = 0;
  VPFE_CCDC_COLPTN    = 0;
  VPFE_CCDC_BLKCMP    = 0;
  VPFE_CCDC_FPC_ADDR  = 0;
  VPFE_CCDC_FPC       = 0;
  VPFE_CCDC_VDINT     = (height-1)<<16;
  VPFE_CCDC_ALAW      = 0;
  VPFE_CCDC_REC656IF  = 0;
  VPFE_CCDC_CCDCFG    = 0x00008000;
  VPFE_CCDC_FMTCFG    = 0;
  VPFE_CCDC_FMT_HORZ  = 0;
  VPFE_CCDC_FMT_VERT  = 0;
  VPFE_CCDC_FMT_ADDR0 = 0;
  VPFE_CCDC_FMT_ADDR1 = 0;
  VPFE_CCDC_FMT_ADDR2 = 0;
  VPFE_CCDC_FMT_ADDR3 = 0;
  VPFE_CCDC_FMT_ADDR4 = 0;
  VPFE_CCDC_FMT_ADDR5 = 0;
  VPFE_CCDC_FMT_ADDR6 = 0;
  VPFE_CCDC_FMT_ADDR7 = 0;
  VPFE_CCDC_PRGEVEN_0 = 0;
  VPFE_CCDC_PRGEVEN_1 = 0;
  VPFE_CCDC_PRGODD_0  = 0;
  VPFE_CCDC_PRGODD_1  = 0;
  VPFE_CCDC_VP_OUT    = 0;
  
  VPFE_CCDC_PCR       = 0x00000001;   // Enable CCDC
  
  if(debug)
  printf("vpfe reinit capt_start=0x%08x!\n",(uint_32)(getvar(CAPT_START)));

}

/* EOF */
