#define DM6435
#include <register.h>
#include <vcrt.h>
#include <vclib.h>
#include <flib.h>
#include <macros.h>
#include <sysvar.h>

#if 0
#include "evmdm6437.h"
#else
#define Uint32  unsigned int

/* ------------------------------------------------------------------------ *
 *                                                                          *
 *   VPFE CCD Controller                                                    *
 *                                                                          *
* ------------------------------------------------------------------------ */
#define VPFE_CCDC_BASE          0x01C70400
#define VPFE_CCDC_PID           *( volatile Uint32* )( VPFE_CCDC_BASE + 0x00 )
#define VPFE_CCDC_PCR           *( volatile Uint32* )( VPFE_CCDC_BASE + 0x04 )
#define VPFE_CCDC_SYN_MODE      *( volatile Uint32* )( VPFE_CCDC_BASE + 0x08 )
#define VPFE_CCDC_HD_VD_WID     *( volatile Uint32* )( VPFE_CCDC_BASE + 0x0c )
#define VPFE_CCDC_PIX_LINES     *( volatile Uint32* )( VPFE_CCDC_BASE + 0x10 )
#define VPFE_CCDC_HORZ_INFO     *( volatile Uint32* )( VPFE_CCDC_BASE + 0x14 )
#define VPFE_CCDC_VERT_START    *( volatile Uint32* )( VPFE_CCDC_BASE + 0x18 )
#define VPFE_CCDC_VERT_LINES    *( volatile Uint32* )( VPFE_CCDC_BASE + 0x1C )
#define VPFE_CCDC_CULLING       *( volatile Uint32* )( VPFE_CCDC_BASE + 0x20 )
#define VPFE_CCDC_HSIZE_OFF     *( volatile Uint32* )( VPFE_CCDC_BASE + 0x24 )
#define VPFE_CCDC_SDOFST        *( volatile Uint32* )( VPFE_CCDC_BASE + 0x28 )
#define VPFE_CCDC_SDR_ADDR      *( volatile Uint32* )( VPFE_CCDC_BASE + 0x2c )
#define VPFE_CCDC_CLAMP         *( volatile Uint32* )( VPFE_CCDC_BASE + 0x30 )
#define VPFE_CCDC_DCSUB         *( volatile Uint32* )( VPFE_CCDC_BASE + 0x34 )
#define VPFE_CCDC_COLPTN        *( volatile Uint32* )( VPFE_CCDC_BASE + 0x38 )
#define VPFE_CCDC_BLKCMP        *( volatile Uint32* )( VPFE_CCDC_BASE + 0x3c )
#define VPFE_CCDC_FPC_ADDR      *( volatile Uint32* )( VPFE_CCDC_BASE + 0x40 )
#define VPFE_CCDC_FPC           *( volatile Uint32* )( VPFE_CCDC_BASE + 0x44 )
#define VPFE_CCDC_VDINT         *( volatile Uint32* )( VPFE_CCDC_BASE + 0x48 )
#define VPFE_CCDC_ALAW          *( volatile Uint32* )( VPFE_CCDC_BASE + 0x4c )
#define VPFE_CCDC_REC656IF      *( volatile Uint32* )( VPFE_CCDC_BASE + 0x50 )
#define VPFE_CCDC_CCDCFG        *( volatile Uint32* )( VPFE_CCDC_BASE + 0x54 )
#define VPFE_CCDC_FMTCFG        *( volatile Uint32* )( VPFE_CCDC_BASE + 0x58 )
#define VPFE_CCDC_FMT_HORZ      *( volatile Uint32* )( VPFE_CCDC_BASE + 0x5c )
#define VPFE_CCDC_FMT_VERT      *( volatile Uint32* )( VPFE_CCDC_BASE + 0x60 )
#define VPFE_CCDC_FMT_ADDR0     *( volatile Uint32* )( VPFE_CCDC_BASE + 0x64 )
#define VPFE_CCDC_FMT_ADDR1     *( volatile Uint32* )( VPFE_CCDC_BASE + 0x68 )
#define VPFE_CCDC_FMT_ADDR2     *( volatile Uint32* )( VPFE_CCDC_BASE + 0x6c )
#define VPFE_CCDC_FMT_ADDR3     *( volatile Uint32* )( VPFE_CCDC_BASE + 0x70 )
#define VPFE_CCDC_FMT_ADDR4     *( volatile Uint32* )( VPFE_CCDC_BASE + 0x74 )
#define VPFE_CCDC_FMT_ADDR5     *( volatile Uint32* )( VPFE_CCDC_BASE + 0x78 )
#define VPFE_CCDC_FMT_ADDR6     *( volatile Uint32* )( VPFE_CCDC_BASE + 0x7c )
#define VPFE_CCDC_FMT_ADDR7     *( volatile Uint32* )( VPFE_CCDC_BASE + 0x80 )
#define VPFE_CCDC_PRGEVEN_0     *( volatile Uint32* )( VPFE_CCDC_BASE + 0x84 )
#define VPFE_CCDC_PRGEVEN_1     *( volatile Uint32* )( VPFE_CCDC_BASE + 0x88 )
#define VPFE_CCDC_PRGODD_0      *( volatile Uint32* )( VPFE_CCDC_BASE + 0x8c )
#define VPFE_CCDC_PRGODD_1      *( volatile Uint32* )( VPFE_CCDC_BASE + 0x90 )
#define VPFE_CCDC_VP_OUT        *( volatile Uint32* )( VPFE_CCDC_BASE + 0x94 )
#endif

void set_res(int width, int height);
int set_image_format(int hpos, int vpos, int hsize, int vsize);
int atoi(char *);

#define VER "1.1"

#define WDLEN_16BIT 2
extern I32 spi_edma_read (U32,U32 *,U32,U32);
extern I32 spi_edma_write(U32,U32 *,U32,U32);

//
// set resolution on vc6211 sensor demo
//
// Author: Michael Steinel Date: 24.03.2011
// 
int no_sysvar_change=1;
int debug = 1;
int hb=0;
int vb=0;
int x = 128; //default:1280
int y = 128; //default:1024

int main(int argc, char * argv)
{
//if(argc) debug = 0;

if(argc) no_sysvar_change = atoi(argv);

if(no_sysvar_change==2)
{
setvar(HWIDTH, 1280);
setvar(VWIDTH, 1024);
setvar(VPITCH, 1280);
printf("RESET sysvars HWIDTH, VWIDTH and VPITCH !!!\n");
}

printf("resolution test routines for VC6211 Version %s\n",VER);
printf("compiled at %s %s\n", __DATE__, __TIME__);
printf("=== use 'mf4 0' option to change sysvars to new resolution    ===\n");
printf("=== use 'mf4 1' option to leave sysvars as they are (default) ===\n");
printf("=== use 'mf4 2' option to reset sysvars to initial values     ===\n");

tpict(); // stop running live mode

//exec2("fd://img2b.exe"); // start monitor

#if 0
//while(1)
{
  int i;
  for(i=0;i<128;i++)
  {
	 set_image_format(i,i,640,240); // move window
	 tpict();
  }
  for(i=128;i;i--)
  {
	 set_image_format(i,i,640,240); // move window
	 tpict();
  }
}
#else
//optional: reset capture queue
//while(cancel_capture_rq());
set_image_format((1280-x)/2,(1024-y)/2,x,y); // automatic centered window
#endif
tpict();

printf("Wait 1s for capture queue empty\n");
time_delay(1000); // wait for capture queue empty

vmode(vmLive); // restart live mode

return 0;
}

int set_image_format(int hpos, int vpos, int hsize, int vsize)
{
int hs=hsize;
volatile U32 rxdata, txdata;
U32 regadr;

if(no_sysvar_change==0)
{
setvar(HWIDTH, hsize);
setvar(VWIDTH, vsize);
}

if(hsize % 64)
{
hsize=(hsize/64)*64+64;
print ("Warning pitch adjusted to multiple of 64!\n");
}

if(no_sysvar_change==0)
{
    setvar(VPITCH, hsize);
    printf("changed sysvars HWIDTH, VWIDTH and VPITCH !!!\n");
}

if(debug)
print("size (h, v, vp):  [%d, %d, %d]\n", hs, vsize, getvar(VPITCH));

if(hpos<0)
  hpos = 0; // minimal value x
if(vpos<0)
  vpos = 0; // minimal value y

if(debug)
print("pos (hpos, vpos):  [%d, %d]\n", hpos, vpos);

if(debug)
print("blanking (hb, vb):  [%d, %d]\n", hb, vb);

// R0x0b sensor state 
regadr = 0x0b;
txdata = 0x0141; // state=STANDBY
if(spi_edma_write(regadr, (U32 *)(&txdata), WDLEN_16BIT,1))
  printf("R0x%02x - SPI write error!!!\n",regadr);
time_delay(2);

// R0x04 line config 
regadr = 0x04;
txdata = 0x8070; // 0x00 => 1 extra line after ROI readout (default = 0x8 => 9 lines)
                 // 0x70 => line length in clk_ctrl cycles (default=0x70)
if(spi_edma_write(regadr, (U32 *)(&txdata), WDLEN_16BIT,1))
  printf("R0x%02x - SPI write error!!!\n",regadr);
time_delay(2);

// R0x14 hpos of ROI1
regadr= 0x14;
txdata = (hpos+6) & 0xffff;
if(spi_edma_write(regadr, (U32 *)(&txdata), WDLEN_16BIT,1))
  printf("R0x%02x - SPI write error!!!\n",regadr);
time_delay(2);

// R0x15 hwidth of ROI1
regadr= 0x15;
txdata = hs & 0xffff;
if(spi_edma_write(regadr, (U32 *)(&txdata), WDLEN_16BIT,1))
  printf("R0x%02x - SPI write error!!!\n",regadr);
time_delay(2);

// R0x12 vpos of ROI1
regadr= 0x12;
txdata = (vpos+6) & 0xffff;
if(spi_edma_write(regadr, (U32 *)(&txdata), WDLEN_16BIT,1))
  printf("R0x%02x - SPI write error!!!\n",regadr);
time_delay(2);
  
// R0x13 vwidth of ROI1
regadr = 0x13;
txdata = vsize & 0xffff;
if(spi_edma_write(regadr, (U32 *)(&txdata), WDLEN_16BIT,1))
  printf("R0x%02x - SPI write error!!!\n",regadr);
time_delay(2);

// R0x39 clamp config | init_line_nb=1 | value for global shutter mode
regadr = 0x39;
txdata = 0x1880; // [14:12] number of init lines before reading matrix = 1 (default = 3)
if(spi_edma_write(regadr, (U32 *)(&txdata), WDLEN_16BIT,1))
  printf("R0x%02x - SPI write error!!!\n",regadr);
time_delay(2);

// R0x41 value for global shutter mode = 0x9630 (default=0xF60F)
regadr = 0x41;
txdata = 0x9630;
if(spi_edma_write(regadr, (U32 *)(&txdata), WDLEN_16BIT,1))
  printf("R0x%02x - SPI write error!!!\n",regadr);
time_delay(2);

#ifdef TEST

// R0x45 value for global shutter mode = 0xA7A5 (default=0xA7A5)
regadr = 0x45;
txdata = 0xA7A5;
if(spi_edma_write(regadr, (U32 *)(&txdata), WDLEN_16BIT,1))
printf("R0x%02x - SPI write error!!!\n",regadr);
time_delay(2);

// R0x46 reset value = 0x0200 (default=0x0300)
regadr = 0x46;
txdata = 0x0200;
if(spi_edma_write(regadr, (U32 *)(&txdata), WDLEN_16BIT,1))
  printf("R0x%02x - SPI write error!!!\n",regadr);
time_delay(2);

// R0x47 reset value = 0x0013 (default=0x0011)
regadr = 0x47;
txdata = 0x0013;
if(spi_edma_write(regadr, (U32 *)(&txdata), WDLEN_16BIT,1))
  printf("R0x%02x - SPI write error!!!\n",regadr);
time_delay(2);

// R0x4A reset value = 0x8EAF (default=0x6026)
regadr = 0x4A;
txdata = 0x8EAF;
if(spi_edma_write(regadr, (U32 *)(&txdata), WDLEN_16BIT,1))
  printf("R0x%02x - SPI write error!!!\n",regadr);
time_delay(2);

// R0x4C reset value = 0x0A1E (default=0x0A1E)
regadr = 0x4C;
txdata = 0x0A1E;
if(spi_edma_write(regadr, (U32 *)(&txdata), WDLEN_16BIT,1))
  printf("R0x%02x - SPI write error!!!\n",regadr);
time_delay(2);

// R0x4D reset value = 0x016F (default=0x2039)
regadr = 0x4D;
txdata = 0x016F;
if(spi_edma_write(regadr, (U32 *)(&txdata), WDLEN_16BIT,1))
  printf("R0x%02x - SPI write error!!!\n",regadr);
time_delay(2);

// R0x4E reset value = 0x798D (default=0x4B5F)
regadr = 0x4E;
txdata = 0x798D;
if(spi_edma_write(regadr, (U32 *)(&txdata), WDLEN_16BIT,1))
  printf("R0x%02x - SPI write error!!!\n",regadr);
time_delay(2);

// R0x4F reset value = 0x555A (default=0x2024)
regadr = 0x4F;
txdata = 0x555A;
if(spi_edma_write(regadr, (U32 *)(&txdata), WDLEN_16BIT,1))
  printf("R0x%02x - SPI write error!!!\n",regadr);
time_delay(2);

// R0x50 reset value = 0x0A0A (default=0x0A1E)
regadr = 0x50;
txdata = 0x0A0A;
if(spi_edma_write(regadr, (U32 *)(&txdata), WDLEN_16BIT,1))
  printf("R0x%02x - SPI write error!!!\n",regadr);
time_delay(2);

// R0x51 reset value = 0x0207 (default=0x0207)
regadr = 0x51;
txdata = 0x0207;
if(spi_edma_write(regadr, (U32 *)(&txdata), WDLEN_16BIT,1))
  printf("R0x%02x - SPI write error!!!\n",regadr);
time_delay(2);

// R0x52 reset value = 0x017B (default=0x014D)
regadr = 0x52;
txdata = 0x017B;
if(spi_edma_write(regadr, (U32 *)(&txdata), WDLEN_16BIT,1))
  printf("R0x%02x - SPI write error!!!\n",regadr);
time_delay(2);

// R0x53 reset value = 0x053E (default=0x053F)
regadr = 0x53;
txdata = 0x053E;
if(spi_edma_write(regadr, (U32 *)(&txdata), WDLEN_16BIT,1))
  printf("R0x%02x - SPI write error!!!\n",regadr);
time_delay(2);

// R0x55 reset value = 0x053C (default=0x053D)
regadr = 0x55;
txdata = 0x053C;
if(spi_edma_write(regadr, (U32 *)(&txdata), WDLEN_16BIT,1))
  printf("R0x%02x - SPI write error!!!\n",regadr);
time_delay(2);

// R0x56 reset value = 0x3F59 (default=0x4059)
regadr = 0x56;
txdata = 0x3F59;
if(spi_edma_write(regadr, (U32 *)(&txdata), WDLEN_16BIT,1))
  printf("R0x%02x - SPI write error!!!\n",regadr);
time_delay(2);

// R0x57 reset value = 0x3F44 (default=0x4044)
regadr = 0x57;
txdata = 0x3F44;
if(spi_edma_write(regadr, (U32 *)(&txdata), WDLEN_16BIT,1))
  printf("R0x%02x - SPI write error!!!\n",regadr);
time_delay(2);

// R0x58 reset value = 0x053C (default=0x053D)
regadr = 0x58;
txdata = 0x053C;
if(spi_edma_write(regadr, (U32 *)(&txdata), WDLEN_16BIT,1))
  printf("R0x%02x - SPI write error!!!\n",regadr);
time_delay(2);

// R0x5A reset value = 0x073D (default=0x073E)
regadr = 0x5A;
txdata = 0x073D;
if(spi_edma_write(regadr, (U32 *)(&txdata), WDLEN_16BIT,1))
  printf("R0x%02x - SPI write error!!!\n",regadr);
time_delay(2);

// R0x5B reset value = 0x053E (default=0x053F)
regadr = 0x5B;
txdata = 0x053E;
if(spi_edma_write(regadr, (U32 *)(&txdata), WDLEN_16BIT,1))
  printf("R0x%02x - SPI write error!!!\n",regadr);
time_delay(2);

// R0x64 reset value = 0x0101 (default=0x011B)
regadr = 0x64;
txdata = 0x0101;
if(spi_edma_write(regadr, (U32 *)(&txdata), WDLEN_16BIT,1))
  printf("R0x%02x - SPI write error!!!\n",regadr);
time_delay(2);

// R0x7A reset value = 0x0004 (default=0x0000)
regadr = 0x7A;
txdata = 0x0004;
if(spi_edma_write(regadr, (U32 *)(&txdata), WDLEN_16BIT,1))
  printf("R0x%02x - SPI write error!!!\n",regadr);
time_delay(2);

#endif // TEST

// R0x0b sensor state 
regadr = 0x0b;
txdata = 0x0140; // state=IDLE
if(spi_edma_write(regadr, (U32 *)(&txdata), WDLEN_16BIT,1))
  printf("R0x%02x - SPI write error!!!\n",regadr);
time_delay(2);

set_res(hsize,vsize); //reprogram DMA
return 0;
}


//MS 24.03.2011 set resolution of camera VC6211
void set_res(int width, int height)
{
    /* capturing video in raw data mode                                                             */
    VPFE_CCDC_PCR       = 0x00000000;    // Disable CCDC

    VPFE_CCDC_HORZ_INFO = (width-1);     // Horizontal lines
    VPFE_CCDC_HSIZE_OFF = getvar(VPITCH);// Horizontal line offset in SDRAM
    VPFE_CCDC_VERT_LINES= height-1;      // Vertical lines
    VPFE_CCDC_VDINT     = (height-1)<<16;

    VPFE_CCDC_PCR       = 0x00000001;    // Enable CCDC

//printf("vpfe reinit capt_start=0x%08x!\n",(uint_32)(getvar(CAPT_START)));

}

/* EOF */
